#Example_135  Generating a simple lung mesh

# If the example path is not set, default to current directory
if (! defined $example) {
    $example = "./";
}
# Drop off the trailing / in the example path
$chopped = chop $example;
if ($chopped ne "/") {
    $example .= $chopped;
}

$RADIUS = 1;

fem de param;r;$example/lungmesh;
fem de coor;r;$example/lungmesh;     #define 3d rectangular cartesian
fem define base;r;$example/lungmesh; #define a 1D linear Lagrange basis func

#CREATE SYMMETRIC CONDUCTING MODEL AND MULTI-BRANCHING RESPIRATORY MODEL
#     read a file that defines a symmetric airway tree (number of 
#     generations, number of elements and their length in each generation).
#     the elements are labelled as 'conducting'. 
fem de mesh;r;$example/lungmesh as conducting field;
#     add a multi-branching respiratory airway mesh to the peripheral 
#     elements in the conducting airway tree. the basis function must 
#     be specified (1d). the elements are labelled as 'respiratory'.
fem de;add mesh;c airway multi_hbw basis_function 1 as respiratory field radius_field 1 alveolar_field 2; 

#CALCULATE RADII AND ALVEOLAR CROSS-SECTIONAL AREA
#     update the conducting airway radii using anatomical data from Weibel (1963)
fem update mesh geometry elem conducting radius_field $RADIUS anatomical weibel;
#     update the respiratory airway radii using anatomical data from 
#     Haefeli-Bleuer & Weibel (1988)
fem update mesh geometry elem respiratory radius_field $RADIUS anatomical hbw;
