# Create a centreline of data points for a surface mesh

# Author: Peter Bier
fem def param;r;$example/tract
# define a rectangular cartesian 3D coordinate system
fem def coord 3,1
# define a bi-cubic hermite basis function for the surface elements
# and a linear lagrange basis for using to interpolate along the circumference
# to calculate the centre of mass.
fem def base;r;$example/tract
# read in the surface mesh node points
fem def node;r;$example/tract
# read in the surface mesh element points
fem def elem;r;$example/tract

# Calculate the centreline data points
# default values for the axial and circumferential xi directions are used
# The default starting element number 1 is also used.
# 2 points will be generated for each element along the axial direction
fem def data;c centreline axis_divisions 2

# list the created data points
fem list data

# export the created data points for viewing
fem export data;centreline

# a centreline mesh can now be created by:
# using the cmgui command gfx snake
# or fitting a line to the data

