#Example_219c: Fitting of surface prolate spheroidal mesh to measured data of endocardial and epicardial surfaces.

fem define para;r;heart;example
fem define coor;r;ellipsoid;example       # prolate spheriodal coords
fem define nodes;r;;example               # 38 nodes, 19 per surface
fem define bases;r;2CubicHermite;example  # bicubic in lambda
fem define ;add bases;r;2Linear;example   # bilinear in mu and theta

$surface = 'endo'                         # choose what surface to fit
#$surface = 'epi' 
fem define elements;r;$surface;example    # 6 elem circumferentially, 3 longitudinally

# Export the initial geometry for viewing in CMGUI
$file = 'heart'
fem export nodes;$file as $file
fem export elements;$file as $file
# This command is temporary until bug in CMISS is fixed:
system "perl -p -i.bak -e 'if(/theta/){s/no modify/decreasing in xi1/}' $file.exelem"

fem define data;r;$surface;example        # read in data for specified surface
fem define xi;c orthog                    # calculate projection of datapoints onto surfacemesh
fem li data err                           # list the RMS of the projection error

# Export the data with error projections for viewing in CMGUI
$file = "${surface}1"
fem export data;$file as $file error
# This command is temporary until bug in CMISS is fixed:
system "perl -p -i.bak -e 'if(/coordinates,/){s/coordinates,/RC coordinates,/}' $file.exdata"

fem define field;r;$surface;example       # create list over nodes to fit including derivatives
fem define elements;r;;example field      # set up element file for field variable
fem define fit;r;surface;example geometry # specify fit problem

#
# First fit
fem fit
fem update node scale_factor
fem update node fit

# Have to read in data again because data is changed to prolate in memory.
# Shouldn't have to do this though. Might be changed in the future...
fem define data;r;$surface;example
fem def xi;c orthog
fem li data err 

# Export the data with error projections for viewing in CMGUI
$file = "${surface}2"
fem export data;$file as $file error offset 20000
# This command is temporary until bug in CMISS is fixed:
system "perl -p -i.bak -e 'if(/coordinates,/){s/coordinates,/RC coordinates,/}' $file.exdata"

# Export fittet geometry after first fit
$file = 'heart_fit1'
fem export node;$file fit as $file offset 1000          
fem export element;$file fit as $file offset_elem 1000
# This command is temporary until bug in CMISS is fixed:
system "perl -p -i.bak -e 'if(/theta/){s/no modify/decreasing in xi1/}' $file.exelem"

#
# Second fit (if not happy with first fit)
fem define fit;r;surface;example geometry
fem fit
fem update node scale_factor
fem update node fit

# Export fittet geometry after second fit
$file = 'heart_fit2'
fem export node;$file fit as $file offset 2000          
fem export element;$file fit as $file offset_elem 2000
# This command is temporary until bug in CMISS is fixed:
system "perl -p -i.bak -e 'if(/theta/){s/no modify/decreasing in xi1/}' $file.exelem"

# Write fitted nodes to file
fem define nodes;w;"${surface}_fitted"



