#Example_312 Steady State Temperature distribution inside an annulus
#            using FEM
 
fem                              #Set the FEM environment
fem define node;r;femannulus;example #Read in the fem annulus nodal coordinates
fem define base;r;;example           #Define a bilinear basis function.
fem list bases                   #List the basis function.
fem define element;r;;example        #Define the fem annulus elements
fem define window;c              #calculates the size of the window to fit
#                                !  the mesh
fem draw axes                    #Draw axes
fem draw node                    #Draw the nodes
fem draw line                    #Draw the lines
fem define equation;r;;example       #Defines the equation to be solved.  We are
#                                !  undertaking a static analysis involving
#                                !  Laplaces equation and we are going to
#                                !  solve it using Galerkin FEM.
fem list equation                #List the equation
fem define material;r;;example       #Define the materials. Since we are dealing
#                                !  with Laplaces equation there are no
#                                !  material properties to be defined.
fem define initial;r;;example        #Define the boundary conditions to be used.
#                                !  The conditions consist of a specified
#                                !  temperature distribution around the inside
#                                !  of the annulus and zero flux on the outside
#                                !  of the annulus with the exception of zero
#                                !  temperature at node 17.
fem draw node                    #Draw the nodes
fem list initial                 #List the initial conditions.
fem define solve;r;;example          #Define the solution options.
fem solve                        #Solves the problem.
fem list node solution           #List the node solution. Compare these with
#                                !  the equivalent BEM example in example_324.
#                                !  Note: the analytic answers for selected
#                                !  (the problem is symmetric) nodes is:
#                                !  Node 17 :  0.00000
#                                !  Node 18 : -0.06091
#                                !  Node 19 : -0.11254
#                                !  Node 20 : -0.14704
#                                !  Node 21 : -0.15915
fem list node flux               #List the node fluxes. Compare these with
#                                !  the equivalent BEM example in example_324.
fem draw field                   #Draw the temperature field
