#Example_313 Steady State Potential distribution on a plate with an
#            anisotropic fibre field
 
fem                                  #Set the FEM environment
fem define node;r;anisoplate;example #Read in the nodal coordinates
fem define base;r;;example           #Define a bilinear basis function.
fem list bases                       #List the basis function.
fem define element;r;;example        #Define the elements
fem define fibre;r;;example          #Define the fibre field (at an angle of 30
#                                    !  degrees to the x-axis).
fem define element;r;;example fibre  #Define the elements
fem define window;c                  #calculates the size of the window to fit
#                                    !  the mesh
fem draw node                        #Draw the nodes
fem draw line                        #Draw the lines
fem draw fibre                       #Draw the fibre field
fem define equation;r;;example       #Defines the equation to be solved.  We
#                                    !  are undertaking a static analysis
#                                    !  involving a generalised Laplaces
#                                    !  equation and we are going to solve it
#                                    !  using Galerkin FEM.
fem list equation                    #List the equation
fem define material;r;;example       #Define the materials. Define the
#                                    !  conductivity in the fibre direction to
#                                    !  be 3 and the conductivity in the
#                                    !  fibre-normal direction to be 1.
fem define analytic;r;;example       #Define the analtyic soltuion for the
#                                    !  problem.
fem define initial;g                 #Generate the initial conditions for the
#                                    !  problem. In this case the initial
#                                    !  conditions are the analytic solution
#                                    !  around the boundary of the mesh i.e.
#                                    !  a Dirichlet problem.
fem list initial                     #List the initial conditions.
fem define solve;r;;example          #Define the solution options.
fem solve                            #Solves the problem.
fem hide node                        #Hide the nodes
fem draw field                       #Draw the contours field
fem draw contour dependent label off #Draw the potential contours
fem draw fibre                       #Bring the fibres to the front
fem check solution                   #Check the accuracy of the solution
 
