#Example_3153 Steady state temperature distribution in a plate (see example_3141).
#This example is used to test the convergence of the Laplace or Poisson equation
#This example is example_3151 refined twice per Zhi. The basis function is bicubic hermite. 
#
fem                                        #Set the FEM environment
fem define parameter;r;lapcub3;example     #Defines the necessary parameters

fem define coordinate;r;lapcub3;example    #Reads in the coordinates used for the plate
fem define nodes;r;lapcub3;example         #Reads in the nodes to define the plate
fem define bases;r;lapcub3;example         #Defines a bicubic hermite basis function
fem define elements;r;lapcub3;example      #Reads in elements from file
fem define wind;c                          #Calculates the graphic window size
fem draw lines                             #Makes the line segments visible
fem define equation;r;lapcub3;example      #Defines a STATIC analysis of LAPLACE's eqn
fem define material;r;lapcub3;example      #Define material properties (none)
fem define initial;r;lapcub3;example       #Defines initial conditions
#                                          !Three sides are held at zero and the forth
#                                          !side has a heat function of Sin(Pi Y/L)
fem define solve;r;lapcub3;example         #Defines solver options, default all settings
fem sol                                    #Solves the boundary value problem
fem draw field                             #This will draw colour temperature field
fem draw contours label off                #Draws 10 contours step size 0.1 deg
