#Example_325 Flow from a cavity into an unsaturated porous media

#           The Yukawa equation (or modified Helmholtz equation) arises
#           in the study of infiltration into unsaturated soils.  The 
#           problem considered below is that of steady infiltration 
#           from a circular cylindrical cavity buried at a large depth 
#           in a porous medium.

fem
fem define node;r;cavityflow;example #the nodal coordinates for the cavity
#                                !  are stored in CAVITYFLOW.ipnode in 
#                                !  the example directory.
fem define window;c  
fem define base;r;;example           #defines a BEM Lagrange/Hermite basis
#                                !  function with quadratic
#                                !  interpolation in 1 Xi coordinate.
fem define element;r;;example        #defines 10 BEM elements.
fem draw node
fem draw element
fem draw line
fem define equation;r;;example       #defines a static analysis of the
#                                !  modified Helmholtz equation by 
#                                !  direct BEM.
fem list equation                #List the equation
fem define material;r;;example       #defines the parameter s
#                                !  (dimensionless size of the cavity) 
#                                !  as constant spatially with value 1.
fem define initial;r;;example        #defines the initial conditions around
#                                !  the cavity as H=e^-s*y.
fem list initial                 #List the initial conditions
fem define solve;r;;example          #defines the solution procedure.
fem solve
fem draw field                   #Draw the solution field
# To obtain the flux from the cavity use the "fem list output" command.
# The cavity flux should be 1.30 (analytic is 1.2902).
