#Sphere BEM test problem. Solves Laplaces equation on a 4x4 element
#sphere of radius 2 with cubic Hermite basis functions. The value of the 
# dependent variable at each of the nodes is set according to  x^2-y^2.
# Solution is checked against the analytic solution for this problem. 

fem define coord 3,1                  #Define 3d
fem define base;r;bemsphere;example   #Define a three basis functions.
#                                     !  a bicubic Hermite BEM basis
#                                     !  and two cubic Hermite sector
#                                     !  BEM basis functions.
fem define mesh;r;;example            #Define a spherical mesh with
#                                     !  4x4 elements, radius 2.
fem define equation;r;;example        #Define a standard Laplace 
#                                     !  equation for the BEM
fem define material;r;;example       #Define materials
#
fem define anal;r;;example             #Calculate the value of the dependent
#                                     !  variable at each of the nodes 
#                                     !  according to x^2+2xy-y^2
#                                     !  of the nodes
fem define initial;g                 #Generate the initial conditions 
#                                     !  as per the analytic equation
fem define solve;r;;example          #Define the solve parameters
fem solve                             #Solve the problem
fem check solution
