# example_338.com - Solving Navier-Stokes flow in a rotating cylinder

fem
fem def para;r;circle;example # Define parameters to allow Voronoi arrays to be used.

fem def node;r;circle;example # Define the nodes of the Voronoi/Delaunay mesh.
fem def base;r;circle;example # Define 2d simplex basis functions.
fem def elem;r;circle;example # Define triangular simplex elements.
fem update delaunay           # Update the Delaunay triangulation to ensure Delaunayism
fem def mesh;r;circle;example # Define a Voronoi mesh. 
fem def equa;r;circle;example # Define equation type. This will be a time integration,
                              # Navier Stokes equation, of a general type, solved 
                              # using finite volumes.
fem def mate;r;circle;example # Define material. This is unimportant as the equations
                              # solved are non-dimensional, ie only depend on the 
                              # Reynolds number. These parameters are used only for
                              # conversion back to dimensional form. This has not
                              # been implemented yet.
fem def init;r;circle;example # Define initial (boundary) conditions. This involves
                              # defining the type (and velocity if using inlet or
                              # wall boundary conditions) at each boundary (B) Voronoi
                              # node.
fem def solv;r;circle;example # Define the solution parameters. 
                              # Always use automatic stepping unless stupid.
                              # As the mesh is fixed, you want to use a sparse LU 
                              # solver (only needs to be factorised once). 
                              # Use QUICK advection (best for steady state cases).
                              # The Courant number scales the maximum allowable
                              # time step by a factor of safety, should be between
                              # 0.3 and 0.7.
fem solv                      # Solve it to steady state.
 
