#Example_431 A square plate under plane strain uniform normal stress
 
fem                            #set up the FEM environment
fem define nodes;r;planestrainplate;example #read in the nodes to define the plate
#                              !  Due to symmetry only model the top-right
#                              !  quarter of the plate
fem define window;c            #Calculate the size of the window
fem define bases;r;;example        #define a bilinear basis function
fem define elements;r;;example     #defines the elements of the plate
fem draw nodes                 #Show the nodes
fem draw lines                 #Show the lines
fem define fibre;d             #Default fibre angle
fem define element;r;;example fibre
fem define equation;r;;example     #define a static linear elastic problem with
#                              !  plane strain elements
fem list equation              #List the equation
fem define material;r;;example     #define the material parameters. Young's modulus
#                              !  is 200 GPa and Poison's ratio is 0.3
fem list material              #List the material
fem define initial;r;;example      #Define the boundary conditions. Due to symmetry
#                              !  the left edge of the plate cannot move in
#                              !  the x-direction and the bottom edge of the
#                              !  plate cannot move in the y-direction. A
#                              !  uniform normal stress of 10 kPa is applied
#                              !  in the x-direction on the right edge of the
#                              !  plate and a uniform normal stress of 5 kPa
#                              !  is applied in the y-directon on the top
#                              !  edge of the plate.
fem list initial               #List the initial
fem draw nodes                 #make the node numbers visible (note the fixed
#                              !  nodal boundary conditions)
fem define solve;r;;example        #Define the solver used.
fem solve                      #solves the boundary value problem
fem draw line deformed dotted scale 3 #draws (scaled) deformed body with
#                              !  dotted lines
fem list node solution         #list the nodal displacements
fem list node reaction         #list the nodal reactions (forces)
fem draw stress scale 0.05     #draw (scaled) principal stress vectors
fem draw reaction scale 0.05   #draw (scaled) reaction (force) vectors
