#Example_521  10% uniaxial extension of a unit cube
 
fem
fem define heading "10% uniaxial extension of a unit cube"
fem define coordinate;r;uniaxial;example #Define 3 GLOBAL RECTANGULAR
#                             !  CARTESIAN coordinates.  Use defaults
#                             !  for other questions. Note that this
#                             !  command writes the coordinates to file
#                             !  UNIAXIAL.ipcoor in your local
#                             !  directory.  UNIAXIAL.ip**** is now
#                             !  the default name for all other files
#                             !  written in this example.
fem define node;r;;example        #Define 8 NODES, 3 COORDINATES, NO
#                             !  PROMPTING FOR VERSION and 0
#                             !  DERIVATIVES for all coordinates.
#                             !  Nodal coordinates are (X,Y,Z):
#                             !  1=(0,0,0); 2=(1,0,0); 3=(0,1,0);
#                             !  4=(1,1,0); 5=(0,0,1); 6=(1,0,1);
#                             !  7=(0,1,1); 8=(1,1,1).
fem define base;r;;example        #Define 3 BASIS FUNCTIONS. Choose
#                             !  LAGRANGE/HERMITE for basis function 1
#                             !  with 3 Xi COORDINATES, a LINEAR
#                             !  LAGRANGE interpolant, and 2 GAUSS
#                             !  POINTS for each Xi direction.  For
#                             !  basis function 2 (hydrostatic pressure)
#                             !  choose an AUXILIARY BASIS with 1
#                             !  AUXILIARY ELEMENT PARAMETER PRESSURE
#                             !  BASIS with 3 Xi coordinates and 2
#                             !  GAUSS POINTS for each Xi direction.
#                             !  Choose POLYNOMIAL DEGREE of 0
#                             !  (ie constant in each direction).
#                             !  Basis function 3 describes surfaces
#                             !  and thus has 2 Xi COORDINATES with
#                             !  LINEAR LAGRANGE interpolant, and 2
#                             !  GAUSS POINTS in each Xi direction.
fem define element;r;;example     #1 ELEMENT with 3 Xj COORDINATES.  BASIS
#                             !  FUNCTION 1 describes each coordinate.
#                             !  Global node numbering is:
#                             !  1,2,3,4,5,6,7,8.
fem define window             #Define 2D (x,y) window
fem draw lines                #Make line segments visible on window.
fem define fibre;d            #  Set up a default fibre angle (aligned 
#                             !  with xi 1)
fem define element;r;;example fibre
fem define equation;r;;example    #Select a STATIC ANALYSIS for a FINITE
#                             !  ELASTICITY, 3-D PROBLEM TYPE. Solve
#                             !  for GEOMETRIC COORDINATES using
#                             !  GALERKIN FINITE ELEMENTS with a
#                             !  NONLINEAR ANALYSIS with a NONLINEAR
#                             !  EQUATION for an INCOMPRESSIBLE
#                             !  material. The basis function for the
#                             !  first three dependent variables is
#                             !  NOT ELEMENT DEPENDENT and is BASIS
#                             !  FUNCTION 1 (an isoparametric analysis)
#                             !  The 4th dependent variable (hydrostatic
#                             !  pressure) is also the same for all
#                             !  elements and is BASIS FUNCTION 2.
#                             !  GLOBAL MATRICES are stored sparsely
#                             !  and the sparsity pattern is CALCULATED
fem define material;r;;example    #Stresses in the constitutive law are
#                             !  referred to BODY (fib/transv) coords.
#                             !  Choose a HYPERELASTIC CONSTITUTIVE
#                             !  LAW for which the strain energy
#                             !  function, W, is a function of
#                             !  PRINCIPAL STRAIN INVARIANTS. The
#                             !  MOONEY-RIVLIN material is expressed as
#                             !  a POLYNOMIAL with MAXIMUM POWER of 1
#                             !  in I1 and I2. The 4 CONSTANT PARAMETERS
#                             !  are 0,2,6,0 defining the strain energy
#                             !  function as W = 2*(I1-3) + 6*(I2-3).
fem define initial;r;;example     #For the initial conditions, there are no
#                             !  PRESSURE BOUNDARY CONDITIONS, or
#                             !  INITIAL DISPLACEMENTS. For dependent
#                             !  variable/equation 1 (X), fix nodes
#                             !  1,3,5,7 by PRESCRIBING an INCREMENT of
#                             !  0.0, and prescribe 0.1 displacement to
#                             !  nodes 2,4,6,8; for dependent variable/
#                             !  equation 2 (Y), fix nodes 1,2,5,6; for
#                             !  dependent variable/equation 3 (Z), fix
#                             !  nodes 1,2,3,4. Do NOT prescribe any bcs
#                             !  for dependent variable/equation 4, or
#                             !  any FORCE bcs.
fem define solve;r;;example       #Select a NEWTON-RAPHSON ITERATION with
#                             !  NO SEARCH or PARALLEL ELEMENT STIFFNESS
#                             !  COMPUTATIONS. FINITE DIFFERENCE
#                             !  derivatives are used with INTERMEDIATE
#                             !  SOLUTIONS AND RESIDUALS VECTORS
#                             !  printed out. Use defaults for
#                             !  subsequent questions.
fem solve step 1 error 1.0D-10  #Solve the problem, resetting the error
#                             !  level for residuals to 1.0D-10 (should
#                             !  converge in about 5 iterations).
fem list initial              #Note that the Lagrange multiplier, p=-13.38
#                             !  ie. hydrostatic pressure=0.5p=-6.69.
fem draw lines deformed dotted  #Draw deformed mesh on window.
fem list strain at 1 ref      #List strain information wrt reference
#                             !  coordinates at 1st gauss point. Strain
#                             !  invariants:I1=3.028, I2=3.026, I3=1.
#                             !  Stretch ratios: lamda(1)=1.1,
#                             !  lamda(2)=lamda(3)=0.9535. Lagrangian
#                             !  Strains:E11=0.105, E22=E33=-0.04545.
fem list stress at 1 ref      #List stress information wrt reference
#                             !  coordinates at 1st gauss point. Cauchy
#                             !  stress in the Xi 1 direction, T11=4.486
#                             !  and should be the only nonzero stress
#                             !  component.
