#Example_522  Uniform biaxial extension of a unit cube
 
fem
fem define coordinate;r;biaxial;example #Defines 3D rectangular cartesian
fem define node;r;;example           #Defines 8 nodes as in uniaxial example
fem define base;r;;example	         #Defines 3 basis functions:
#                                !  1) Lagrange/Hermite with 3 Xi coords;
#                                !  2) Auxiliary bsis with 3 Xi coords;
#                                !  3) Linear Lagrange with 2 Xi coords.
fem define element;r;;example        #Defines 1 element.
fem define window                #Define 2D window.
fem draw lines                   #Make line segments visible on window.
fem define fibre;d               #Use the default fibre angle
fem define element;r;;example fibre
fem define equation;r;;example       #Defines a finite elasticity problem.
fem define material;r;;example       #Defines a hyperelastic constitutive
#                                !  law.
fem define initial;r;;example        #Define NO PRESSURE BOUNDARY CONDITIONS
#                                !  or INITIAL DISPLACEMENTS. Dependent
#                                !  variable 1 fixes nodes 1,3,5,7 by an
#                                !  increment of 0.0, and nodes 2,4,6,8
#                                !  with displacement 0.1.  Nodes 1,2,5,6
#                                !  are fixed with 0.0 for dependent
#                                !  variable 2, and nodes 3,4,7,8 have a
#                                !  displacement of 0.1.Fix nodes 1,2,3,4
#                                !  for dependent variable 3. No bcs are
#                                !  prescribed for dependent variable 4,
#                                !  and there are no force bcs.
fem define solve;r;;example          #Defines a Newton-Raphson iteration.
fem solve step 1                 #Solve the problem (should converge in
#                                !  about 3 iterations).
fem list initial                 #Note the Lagrange multiplier, p=-11.28
#                                !  Thus hydrostatic pressure=0.5p=5.64.
fem draw line deformed dotted    #Draw deformed mesh on window.
fem list strain at 1 ref         #List strain information wrt reference
#                                !  coordinates at 1st gauss point.
#                                !  Strain invariants:I1=3.103,I2=3.117,
#                                !  I3=1.  Stretch ratios: lamda(1)=
#                                !  lamda(2)=1.1, lamda(3)=0.8264.
#                                !  Lagrangian strains: E11=E22=0.105,
#                                !  E33 =-0.1585.
fem list stress at 1 ref         #List stress information wrt reference
#                                !  coordinates at 1st gauss point.
#                                !  Cauchy stress in the Xi 1 direction,
#                                !  T11=T22=9.76.  Other components
#                                !  should be close to 0.
