#Example_529  Shear of unit cube in xz-plane; first principal stress fitted 
#             and exported to cmgui

#            Note that principal stress is fitted and exported 
#              to frontend.

fem de parameters;r;sheared_cube;example

fem define coordinate;r;;example #Defines 3D rectangular
#                              !  cartesian coordinates.
fem define node;r;;example         #Defines 8 nodes in a unit cube.
fem define base;r;;example         #Defines 3 basis functions: linear
fem define element;r;;example      #Defines 1 element
fem define fibres;r;;example
fem define elem;r;;example fibre
fem define window;r;;example on 3  #Applied shear will be in xz plane
fem draw lines
fem define equation;r;;example lock  #Defines 3D finite elasticity.
fem define material;r;;example     # Mooney-Rivlin material where a=1, b=0.2
fem define initial;r;;example      #Defines simple shear in xz plane.
fem define solve;r;;example                 
fem solve
fem draw line deformed dotted
fem update gauss stress principal #Principal stresses in YG gauss point
#                              !  array.
fem list gauss yg
fem list stress at 1 ref      #List stress information wrt reference 
#                             !  coordinates at 1st gauss point.
#                             !  2nd Piola-Kirchhoff stress wrt Reference
#                             !  coords, T11=-0.7250 T13=-1.250,T33=-0.100
#                             !  Cauchy stresses wrt Reference coords,
#                             !  T11=0.500 T13=1.200,T33=-0.1000
#                             !  and should be the only nonzero stress 
#                             !  components.    
fem list strain at 1 ref      #List strain information wrt reference
#                             !  coordinates at 1st gauss point. Strain
#                             !  invariants:I1=3.250, I2=3.250, I3=1.
#                             !   Lagrangian Strains:E13=0.25, 
#                             !   E33=-0.125, Principal strains,
#                             !   0.3202D+00,-0.1368D-47,-0.1952D+00
fem update geometry from solution #Transfer deformed coordinates to 
#                              !  geometry. 
fem define field;r;;example        #Sets up one field component.
fem define element;r;;example field #Sets up field elements
fem define fit;r;;example gauss    #Gauss point fit.
fem fit                        #Fit first principal stress.
fem export element;sheared_cube #For use with cmgui.
fem export node;sheared_cube   #Note: nodes are in deformed position.
