
# If the example path is not set, default to current directory
if (!defined $example) {
    $example = "./";
}
# Drop off the trailing / in the example path
$chopped = chop $example;
if ($chopped ne "/") {
    $example .= $chopped;
}

#Define livegraphics function
sub drawResult($liveGraphics)
{
  if($liveGraphics)
  {
     fem draw line def dot
     refresh graphics
  }
}
$liveGraphics=1
#**************************************************************
#Set up CMISS mechanics model
#
#
fem def para;r;emech;example 
fem def coor 3,1
# default nodes, elements and grids to get a single grid point
fem define bas;r;TriCubicHerm;example 
fem def;add base;r;BiCubicHerm;example 
fem def;add base;r;TriLinearPress;example 
fem def;add base;r;BiLinear;example 
fem define node;r;2Elem_unitCube;example 
fem define elem;r;2Elem_unitCube;example 
fem def fibre;r;2Elem_unitCube;example 
fem def elem;r;2Elem_unitCube;example  fibre
fem def equa;r;mechanics;example  lock
fem def mat;r;mooney_rivlin;example 
fem group node 1,2,3,4 as BOTTOMNODES
fem group node 9,10,11,12 as TOPNODES
#fem group node 5,6,7,8 as TOPNODES
fem group node 1,2,5,6,9,10 as FRONTNODES
fem group node 3,4,7,8,11,12 as BACKNODES
fem group node 1,3,5,7,9,11 as LEFTNODES
fem group node 2,4,6,8,10,12 as RIGHTNODES
fem def init;r;shear;example 
fem def solve;r;cubeherm;example 
fem def wind on xz;c
fem draw line
refresh graphics
fem export node;2Elem_unitCube as 2Elem_unitCube
fem export elem;2Elem_unitCube as 2Elem_unitCube
#In this example we define displacements
#**************************************************************
#
#**************************************************************
fem solv inc 0.0001 iter 5 error 0.0000001
&drawResult($liveGraphics);
fem solv inc 0.0009 iter 5 error 0.0000001
&drawResult($liveGraphics);
fem solv inc 0.009 iter 5 error 0.0000001
&drawResult($liveGraphics);
fem solv inc 0.09 iter 5 error 0.0000001
&drawResult($liveGraphics);
fem solv inc 0.4 iter 5 error 0.0000001
&drawResult($liveGraphics);
fem solv inc 0.5 iter 15 error 0.0000001
&drawResult($liveGraphics);

fem export node;sheared2Elem_unitCube as sheared2Elem_unitCube field offset=0
fem export elem;sheared2Elem_unitCube as sheared2Elem_unitCube field offset_elem=0
#view in cmgui if desired
#system "cmgui loadResult.com" 

