#Example_532 Inflation of a 2 element cylinder using r2 interpolation
#
#
#           N   N  OO  TTT EEE
#           NN  N O  O  T  E
#           N N N O  O  T  EEE
#           N  NN O  O  T  E
#           N   N  OO   T  EEE
#
#  ERROR: There is a problem using r^2 interpolation and pressure boundary
#         conditions - produces singular arrays and needs fixing
#
#
#
#
 
fem
fem define coordinates;r;cylind2;example #3D cylindrical polar coordinates,
#                              !  with r^2 interpolation.
fem define node;r;;example         #Defines 6 nodes.
fem define base;r;;example         #Defines 3 basis functions.
fem define element;r;;example      #Defines 2 elements.
fem define window;r;;example       #Defines window dimensions.
fem draw lines                 #Draws undeformed mesh on window.
fem define fibre;d                 #Default fibre angles
fem define element;r;;example fibre
fem define equation;r;;example     #Defines finite elasticity equations.
fem define material;r;;example     #Incompressible Mooney-Rivlin material.
fem define initial;r;;example      #Internal pressure of 1, external 0
#                              !  constrain axial movement at centre
#                              !  nodes.
fem define solve;r;;example        #Residual and intermediate output.
fem solve step 1
fem draw lines def dot         #Draw deformed mesh.
fem list strain at 1 ref       #List strain wrt reference coordinates
#                              !  at 1st Gauss point.
fem list stress at 1 ref       #List stress wrt reference coordinates
#                              !  at 1st Gauss point.
fem list elem tot
fem list elem def tot
             #Note the differences in strain and stress results in
             #  comparison to the previous problem.  The third strain
             #  invariant indicates that volume is conserved (I3=1);
             #  the inner radial stress is close to -1 while the outer
             #  radial stress is close to zero (when all Gauss points
             #  results are displayed).
