#Example_533  Inflation and 10% axial extension of a cylinder with
#             fibre distribution
 
fem
fem define coordinate;r;cylfib;example #Defines cylindrical polar coords.
fem define node;r;;example         #Define 4 NODES, 3 COORDINATES, NO
#                              !  VERSION PROMPTING, 0 DERIVATIVES for
#                              !  all coordinates. Nodal coordinates
#                              !  (Xj) are (R,theta,Z): 1=(1,0,0);
#                              !  2=(1,0,1); 3=(1.49,0,0); 4=(1.49,0,1).
#                              !  (1/1.49=Ri/Ro=0.671).
fem define base;r;;example         #Defines 3 basis functions.
fem define element;r;;example      #Defines 1 element.
fem define fibre;r;;example        #Choose the default options for the first
#                              !  questions, then set the inner nodes
#                              !  1,2 oriented at 75 degrees and the
#                              !  outer nodes 3,4 at -45 degrees from
#                              !  the axis.
fem define element;r;;example fibre
fem define window;r;;example       #Define window dimensions in X,Y,Z
#                              !  directions as (min,max): (-2,2),
#                              !  (-2,2), (-1,2).
fem draw lines                 #Make line segments visible on window.
fem define equation;r;;example     #Same as in the uniaxial problem.
fem define material;r;;example     #Choose defaults for first 3 questions, then
#                              !  define W as an EXPONENTIAL function
#                              !  with 5 CONSTANT PARAMETERS.  The
#                              !  constants alpha(i) were optimized
#                              !  parameters from experimentally
#                              !  determined epicardial strains from the
#                              !  isolated canine heart: alpha(1)=0.641,
#                              !  alpha(2)=2.929, alpha(3)=10.82,
#                              !  alpha(4)=0, alpha(5)=14.08.
fem define initial;r;;example      #BOUNDARY PRESSURE INCREMENT are entered
#                              !  with HYDROSTATIC PRESSURE matched
#             !  across elements. INITIAL DISPLACEMENTS are ALL ZERO.
#             !  For DEPENDENT VARIABLE/EQUATION 2 (theta-direction),
#             !  fix nodes 1,3 and prescribe nodes 2,4 to displace
#             !  -0.0393/outer radius or -0.02637 radians (from
#             !  optimized parameters fitted to experimental data); for
#             !  DEPENDENT VARIABLE/EQUATION 3 (Z-direction), fix nodes
#             !  1,3 and apply 0.111 displacement to nodes 2,4;
#             !  Pressure bcs are applied via DEPENDENT VARIABLE/
#             !  EQUATION 4. For ELEMENT 1, DO NOT prescribe bcs for
#             !  parameters 1,2,3; apply inner pressure bc by
#             !  prescribing an INCREMENT of 1.67 to parameter 4; apply
#             !  outer pressure bc by prescribing an INCREMENT of 0.0 to
#             !  parameter 5. Prescribe NO FORCE BOUNDARY conditions.
#
fem define solve;r;;example        #Defines solution information.
fem solve increment 0.1 error 1.0E-10 #Solve the problem incrementally,
#                              !  starting with 10% of the prescribed
#                              !  conditions. This will simulate
#                              !  different stages of passive filling.
fem solve increment 0.4 error 1.0D-10 #Solve the problem with an
#                              !  additional 40% of the prescribed
#                              !  conditions (total = 50%).
fem solve increment 0.5 error 1.0D-10 #Solve the problem for the last
#                              !  increment, totally 100% of the
#                              !  prescribed conditions.
fem draw lines deformed dotted #Draw deformed mesh.
fem list strain ref            #List strain information wrt reference
#                              !  coordinates.
fem list stress ref            #List stress information wrt reference
#                              !  coordinates.
