# Example 539: Passive inflation of a tricubic hermite cylinder in 
#              rectangular-cartesian coordinates

#set num_threads 4   # Set the number of threads for multiprocessing machines
fem
fem define parameters;r;cylinder;example
fem define coor;r;3drc;example

fem define bases;r;3CubicHermite_4x4x4Gauss_HarmMeanSE;example reg 1             #1 Geometry
fem define ;add bases;r;2CubicHermite_4x4Gauss_ArithMeanSE;example reg 1         #2 Faces
fem define ;add bases;r;2Linear-CubicHermite_4x4x4Gauss_HarmMeanSE;example reg 1 #3 Fibre angle
fem define ;add bases;r;3Linear_4x4x4Gauss;example reg 1                         #4 Imbrication angle
fem define ;add bases;r;Linear-2CubicHermite_4x4x4Gauss_HarmMeanSE;example reg 1 #5 Sheet angle
fem define ;add bases;r;Linear-CubicHermite_4x4x4Gauss_HarmMeanSE;example        #6 Faces
fem define ;add bases;r;2Linear_4x4Gauss;example reg 1                           #7 Faces
fem define ;add bases;r;CubicHermite-Linear_4x4x4Gauss_HarmMeanSE;example        #8 Faces
fem define ;add bases;r;3Linear-2PressAuxXi3_4x4x4Gauss;example                  #9 Pressure

fem define nodes;r;cylinder;example reg 1                      # 4 element cylindrical mesh
fem define elements;r;cylinder;example reg 1      
fem define fibre;r;cylinder;example reg 1                             
fem define element;r;cylinder;example fibre reg 1

fem define equation;r;finelas_tch_incomp;example  class 1 reg 1     
fem define material;r;orth_incomp;example class 1 reg 1   

fem define initial;r;cylinder;example class 1 reg 1  

fem define solve;r;newton;example class 1 reg 1  

read com;solve_inflate;example reg 1 class 1



