# This awk script adds the Gauss point fibre angles to Gauss point
# stress information for specified elements.
#
# Usage: 
#   nawk -v angle=ANGLE -f extract_angles_stresses.awk element_numbers_file angles_file stresses_file 
#     element_numbers_file - contains the specified element
#       numbers. One element number per line.
#     angles_file - contains the output of the CMISS command 
#       FEM evaluate field 
#     stresses_file - is a CMISS .opstre file, created by the command
#       FEM list stress
#     ANGLE - is another column to plot against
# Created: 
#   Carey Stevens, Wed Mar 22 16:01:33 NZT 2000
# Updates: 
#

BEGIN   {
               
		i=1;
		in_element = 0;
                this_file = "";
                fibre = 1;
                imbric = 2;
                sheet = 3;
		max_gauss_number=1;
        }
FILENAME!=this_file     {
                file_number++;
                this_file = FILENAME;
        }
file_number==1  {
                elements[i] = $1;
		i++;
        }
file_number==2  {
                        if($1=="Element")
                        {
				element_number=$2;
			}	
                        if($1=="ng=")
                        {
				gauss_number=$2;
                                fibre_angles[element_number,gauss_number,fibre] = $13;
                                fibre_angles[element_number,gauss_number,imbric] = $14;
                                fibre_angles[element_number,gauss_number,sheet] = $15;
                        }
	}
file_number==3  {
                        if($1=="Element")
                        {
				element_number=$2;
			}	
                        if($1=="ng=")
			{	
				gauss_number=$2;
				if(gauss_number > max_gauss_number)
				{
					max_gauss_number=gauss_number;
				}
			}
                        if($1=="TG(1,i):")
                        {
                                TG[element_number,gauss_number,1,1] = $2;
                        }
       	}
END	{
		
		printf("# Gauss pt, fibre, imbrication, sheet, TG(11)\n");
		for(i in elements)
		{
			element_number=i
			printf("# Element %s\n",element_number);
			for(gauss_number = 1;  gauss_number <= max_gauss_number; gauss_number++)
			{
			printf("%s %s %s %s %s %s\n",gauss_number,
				fibre_angles[element_number,gauss_number,fibre],
				fibre_angles[element_number,gauss_number,imbric],
				fibre_angles[element_number,gauss_number,sheet],
				TG[element_number,gauss_number,1,1],
				angle);
			}
		}
	}