# This awk script adds the Gauss point fibre angles to Gauss point
# stress information for specified elements.
#
# Usage: 
#   nawk -v angle=ANGLE -f extract_angles_stresses.awk element_numbers_file fibre_strains_file wall_strains_file 
#     element_numbers_file - contains the specified element
# Created: 
#   Carey Stevens, Tue Mar 28 21:18:24 NZT 2000
# Updates: 
#

BEGIN   {
               
		i=1;
		in_element = 0;
		in_EG = 0;
                this_file = "";
                fibre = 1;
                imbric = 2;
                sheet = 3;
		max_gauss_number=1;
        }
FILENAME!=this_file     {
                file_number++;
                this_file = FILENAME;
        }
file_number==1  {
                elements[i] = $1;
		i++;
        }
file_number==2  {
                        if($1=="Element")
                        {
				element_number=$2;
			}	
                        if($1=="ng=")
			{	
				gauss_number=$2;
				if(gauss_number > max_gauss_number)
				{
					max_gauss_number=gauss_number;
				}
			}
                        if($1=="EG(1,j):")
			{
				in_EG=1;
			}
			if(in_EG && $1=="2")
			{
                                EGf[element_number,gauss_number,2,2] = $3;
			}
			else if(in_EG && $1=="3")
                        {
                                EGf[element_number,gauss_number,2,3] = $3;
                                EGf[element_number,gauss_number,3,3] = $4;
                        }
			if($1=="Deformation")
			{
				in_EG=0;
			}
	}
file_number==3  {
                        if($1=="Element")
                        {
				element_number=$2;
			}	
                        if($1=="ng=")
			{	
				gauss_number=$2;
				if(gauss_number > max_gauss_number)
				{
					max_gauss_number=gauss_number;
				}
			}
                        if($1=="EG(1,j):")
			{
				in_EG=1;
			}
			if(in_EG && $1=="2")
			{
                                EGw[element_number,gauss_number,2,2] = $3;
			}
			else if(in_EG && $1=="3")
                        {
                                EGw[element_number,gauss_number,2,3] = $3;
                                EGw[element_number,gauss_number,3,3] = $4;
                        }
			if($1=="Deformation")
			{
				in_EG=0;
			}
       	}
END	{
		
		printf("# Gauss pt, EGw22, EGw23, EGw33, EGf22, EGf23, EGf33, Sheet angle\n");
		for(i in elements)
		{
			element_number=i
			printf("# Element %s\n",element_number);
			for(gauss_number = 6;  gauss_number <= 6; gauss_number++)
			{
			printf("%s %s %s %s %s %s %s %s\n",gauss_number,
				EGw[element_number,gauss_number,2,2],
				EGw[element_number,gauss_number,2,3],
				EGw[element_number,gauss_number,3,3],
				EGf[element_number,gauss_number,2,2],
				EGf[element_number,gauss_number,2,3],
				EGf[element_number,gauss_number,3,3],
				angle);
			}
		}
	}