### using general Blatz-Ko strain energy function    
### to solve an unit compressible cube 
### W=0.5*mu*alpha*[(J1-3)+beta*(J3^(-2/beta)-1)]
###   +0.5*mu*(1-alpha)*[(J2-3)+beta*(J3^(2/beta)-1)]
### where J1=I1, J2=I2/I3, J3=I3^0.5, beta=(1-2*nu)/nu,
### nu is Poisson's ratio 
###
###
fem define parameters;r;Blatz-Ko;example;		
fem define coordinates;r;;example;         # 3D rectangular cartesian (x,y,z).
fem define base;r;;example;                # 3D linear Lagrange.
fem define nodes;r;;example;  		
fem define elements;r;;example;
fem define fibre;r;;example;               # Default all fibre angles to zero 
#                                          # for isotopic material.
fem define elements;r;;example fibre;
fem define equation;r;;example;            # 3D compressible finite elasticity
fem define material;r;;example;            # Blatz-Ko material, mu=1, alpha=0,
#                                          # nu=0.25.
fem define initial;r;;example;             # Uniaxial elongation 0.25 in x-direction.
fem define solve;r;;example;			
fem solve;
#fem list stress full;                          # List second Piola-Kirchhoff & Cauchy stresses.
#fem update geometry from solution;
#fem list elements;                        # List lambda1, lambda2, lambda3









