# If the example path is not set, default to current directory
if (!defined $example) {
    $example = "./";
}
# Drop off the trailing / in the example path
$chopped = chop $example;
if ($chopped ne "/") {
    $example .= $chopped;
}
#**************************************************************
#
# allocate memory for program arrays etc.
fem def para;r;memory;example
#**************************************************************
#
# Set up beam geometry
fem def coor 3,1
fem def base;r;TriCubicHerm;example #basis function for interpolation of 3d coords
fem def;add base;r;BiCubicHerm;example #for interpolation of coords on 2D surfaces
fem def;add base;r;TriLinearPress;example #interpolates hydrostatic pressure
fem def;add base;r;BiLinear;example 
#The geometry being subjected to gravity load is a cuboid 60mm long,(x-direction) 40X40 mm in y,z directions
fem def node;r;beam;example
fem def elem;r;beam;example
fem def fibre;r;beam;example
fem def elem;r;beam;example fibre
#
#group nodes that are against the wall for cantilever setup. Certain degrees of freedom for these nodes will be fixed in the ipinit file
#to simulate the cantilever setup
fem group node 1,6,11,16,21,26,31,36,41 as BACKNODES
fem def equa;r;mechanics;example #use 3D finite elasticity to simulate the deformation
#
#apart from the neo_hookean parameter, you need to give the density of the body..
#units for this model
#
# Density in gram per millimeter cubed 
# gravity m/(sec squared). 
# This means force is in mN. Therefore stress will be in kPa (kN/squared m)or (mN/squared mm)
# so neo-Hookean param is in kPa
fem def mate;r;neo_hookean;example 
#
#The gravity vector is set in the ipinit file. 
fem def init;r;gravity;example
#
#Define the nonlinear equations solution algorithm to be used
#I have chosen modified newton with LU factorisation. The LU factorisation
# can be slow, but with modified newton, the total time taken can actually be reduced
fem def solv;r;modif_newton;example
#**************************************************************
#
# solve the problem
fem solv inc 0.5 iter 100
fem solv inc 0.5 iter 100
#**************************************************************
#
#view the deformed state on the gx window
fem def wind on xz;c
fem draw line
fem draw line def dot
