# Example 5g4

# If the example path is not set, default to current directory
if(!defined $example)
{
  $example = "./";
}

fem def param;r;full_big;example
fem define coor;r;rcCoord;example
fem define base;r;basisfuncs;example
#
fem define nodes;r;rc3;example
fem define elements;r;rc;example
fem define fibre;r;simple;example
fem define element;r;simple;example fibre
  
# Material parameter groups
fem group elem 1..4 as apexElems
fem group elem 5..12 as betweenElems
fem group elem 13..16 as baseElems
fem group elem 5..16 as notApexElems

# Boundary Condition groups
fem group nodes 1,18 as fixedApexNodes
fem group nodes 14..17,31..34 as fixedBaseNodes
fem group nodes 14,16 as y_axisNodes
fem group nodes 15,17 as z_axisNodes

# Residual strains groups
fem group nodes 6..13 as nodes095
fem group nodes 1..5,14..22,31..34 as nodes100
fem group nodes 23..30 as nodes105

$name = "heartOriginal"
$file = $name
fem export nodes;$file as $name offset 1000
fem export elements;$file as $name offset_elem 1000

fem define equation;r;equation;example lock
fem define material;r;polezero_gauss;example
fem define acti;r;calcium000;example

fem define initial;r;x_Base_node_restricted;example
fem define solve;r;solve;example

fem list elements total

fem solve increment 1 iter 30 error 10e-8

fem list elements deformed total

$name = "heartInflated"
$file = $name
fem export nodes;$file field as $name offset 0000
fem export elements;$file field as $name offset_elem 0000

fem list strain;strain fibre
fem list stress;stress fibre total 

$file = "heartStress"
fem update gauss stress fibre total Cauchy
fem export gauss;$file yg as gauss_stress offset 0

$file = "heartStrain"
fem update gauss strain fibre extension_ratios
fem export gauss;$file yg as gauss_strain

fem update geometry from solution
$file = "heartInflated"
fem define nodes;w;$file
