#Example_711:  Find material parameters of 2D membrane under biaxial stretch
# by optimisation (Note that this example generates the nodal forces from the
# fem solution rather than reading in a deformed geometry and a set of forces)

fem de node;r;membrane;example    #4 nodes
fem de base;r;;example            #bilinear
fem de elem;r;;example            #1 element
fem de fibr;r;;example            #zero fibre angles
fem de elem;r;;example fibre      #fibre elements
fem de wind
fem draw lines
fem draw nodes                    #note bdry conditions
fem de equa;r;;example lock       #finite elastic membrane
fem de mate;r;;example            #pole-zero with default params
fem de init;r;;example            #pull on top right corner
fem de solv;r;;example
fem solve
fem draw lines deformed dotted
fem draw strain rgb=blue          #principal strains
fem draw stress rgb=green         #principal stresses
#                        !note that principle stress dir.n not same as strain
fem list strain xi 1 points 5 
fem list stress xi 1 points 5 
fem draw reactions           #nodal forces
fem de optimise;r;;example   #find 2 axis coeffs of pole-zero law
#                            !minimise sum of squared residuals
#                            !parameters initially zero, range 0 - 10
fem eval residuals wrt mat_params with 1.937,0.028 #true params give zero resids
fem eval residuals wrt mat_params #current (zero) params give non-zero resids
optimise                     #should return exact material parameters
fem list optimise            #list optimised material parameters
fem list material            #list the original material params and check that
#                            !optimised params agree with orig params 1 and 4
