#This example is a scaled down testing vesion of example 7182. Two material parameters are estimated using two deformed states and #bi-linear basis functions
# If the example path is not set, default to current directory
if (!defined $example) {
    $example = "./";
}
# Drop off the trailing / in the example path
$chopped = chop $example;
if ($chopped ne "/") {
    $example .= $chopped;
}
#**************************************************************
@DATASETS = (12,14)								#Deformed states

fem define parameters;r;multiaxes;example
	
fem define bases;r;bases_line;example						#Bi-linear
fem define nodes;r;coordinates_line_undeformed;example
fem define elements;r;elements_line;example					#Circular mesh with 192 elements

fem define fibre;r;fibre;example
fem define elements;r;fibreelem_line;example fibre

fem define equation;r;equation;example						#Incompressible membrane (uses plain-stress)
fem define material;r;tongfung;example						#Tong and Fungs skin function

fem group nodes 1..32 as BOUNDARY

fem define data;r;datapoints_undeformed;example					#Reads the undeformed coordinates of the datapoints
foreach $index (@DATASETS[1..$#DATASETS]){
	fem define data;r;datapoints_undeformed;example append
}

fem define xi;c closest								#Defines the xi positions of the datapoints

fem define data;r;datapoints_${DATASETS[0]};example as IMAGE_${DATASETS[0]}	#Reads the deformed coordinates of the datapoints
foreach $index (@DATASETS[1..$#DATASETS]){
	fem define data;r;datapoints_${index};example append as IMAGE_${index}
}
symlink "$example/evalresid_line.com","evalresid_line.com"
fem define initial;r;initskinsolve_line;example					#Defines a force boundary problem
fem define solve;r;solve;example
fem define optimise;r;tongfung_line;example					#Estimate twe exponential material parameters

fem define nodes;r;displacements_line_$DATASETS[-1];example dep 2 nc 1
fem define nodes;r;force_line_$DATASETS[-1];example dep 2 nc 2			#Reads the experimentaly applied forces
fem define nodes;r;force_line_residual;example dep 1 nc 2			#Reads the estimated residual forces

fem solve increment 0.1 iterate 100
for $M (1..3)
{
	fem solve increment 0.3 iterate 100					#Solves the force boundary
}

optimise									#The optimiser calles the eval_resid_line.com file

fem list data errors deformed
fem list material constitutive
