fem de param;r;alveoli;example;          #defines parameters
fem de coor 3,1;                         #defines coordinates
fem de reg;r;three;example;              #defines 3 regions
fem de base;r;alveoli;example;           #defines linear 1D, 2D, 3D and simplex 2D, 3D bases
fem de node;r;cube_host;example reg 1;   #defines 3D unit cube host
fem de elem;r;cube_host;example reg 1; 
fem export node;cube as cube reg 1;      #exports cube host for viewing
fem export elem;cube as cube reg 1;
fem de node;c delaunay reg 1 target 2 div 4 rad 0.01 internal; 

#creates delaunay seed points within host region 1 in target region 2, using 4 divisions of 
#cube volume, radius of 0.01 for internal boundary and boundary nodes and defines 
#regularly spaced internal seed points

fem de mesh;c delaunay basis 4 B boundary IB internal_boundary IN_nodes internal reg 2;

#specifies boundary, internal boundary, and internal node groups in region 2

fem update delaunay reg 2;
fem de mesh;c voronoi basis 3 B boundary IB internal_boundary IN_nodes internal convert reg 2 target 3 gen 3;

#calculates the Voronoi mesh based on the defined Delaunay nodes in region 2
#converts the Voronoi cells to nodes and 1-D elements into target region 3
#gen 3 specifies 3 generations (bifurcations) of alveolar ducts

fem export node;cell as cell reg 3;      #exports Voronoi nodes
fem export elem;alveoli as alveoli elem alveoli reg 3; #exports Voronoi 
fem export elem;duct as duct elem duct reg 3;
fem 


#NB/ Different results are obtained on linux than on the irix and aix operating 
#systems the small differences are generated in the delaunay triangulation 
#procedure and are most probably due to differences in rounding on the 2 
#platforms. Therefore different results are compared in ndiff on the different 
#platforms (16th June 2003).

