# Example 9822

# If the example path is not set, default to current directory
if (! defined $example) {
    $example = "./";
}
# Drop off the trailing / in the example path
$chopped = chop $example;
if ($chopped ne "/") {
    $example .= $chopped;
}

fem define param;r;$example/flow;

fem define coord;r;$example/flow;
fem define base;r;$example/flow;

fem de node;r;trunk as parent;
fem de elem;r;trunk as parent;

#evaluate ordering of parent vessels before creating symmetric mesh
fem evaluate order; 
#Now set up a symmetric mesh 
fem de mesh;c lung symmetric num_generation 4 branch_angle 40 elem parent;

fem define mesh;c lung field only_radius_field; 
#only sets up radius field

fem evaluate order;
#fem update mesh geometry radius_field 1 anatomical Arteries;

fem update mesh geometry radius_field 1 element 1 constant 12;
fem update mesh geometry radius_field 1 Rd_strahler ratio_diameter 1.5997;

fem de elem;w;test;
fem de elem;r;test; #sets up NLL - element length array

#adds two more fields to store the pressure and velocity fields, adds 0 as default value
fem define;add field;d;$example/arteries;
#fem define field;w;test;
fem define element;d;$example/arteries field;

fem define grid;r;$example/flow coronary;
# Defines grid points with coronary option to discretise the spatial computational domain. 
fem update grid geometry;
fem define equation;r;$example/flow;       # Defines equations                          
fem define material;r;$example/flow;       # Reads in physical & mechanical properties
fem update material field material 4 no_field 1;
fem define time;r;$example/step;        
fem define initial;r;$example/flow;        # Defines initial conditions
fem define solve;r;$example/flow;          # Defines solution parameters

$time_initial=0.00;                       # Sets the initial time
$time_final=1.5;                         # Sets the final time
$time_step=0.001;                        # Sets the time step time
$write_out_period=0.1;                 # Sets the results write out period

fem export points;$time_initial grid as vessel offset 0;   
fem export grid;vessel as vessel offset_node 0 elastic_tube; 

# Results output loop

for ($time=$time_initial;$time<$time_final;$time=$time+$write_out_period)
{
fem solve restart to $write_out_period delta_t $time_step;
fem export points;$time+$write_out_period grid as vessel offset 0
}                                                                           

set output;cmiss_test on;
fem list nodes
set output off
fem quit;
