#
# Example b143 - SPM calcium dynamics
#

$SIGNALS = "1..7";

fem def para;r;n98_hmt;example

fem def node;d
fem def base;d
fem def element;d
fem def grid;d
fem update grid geom
fem update grid metric

fem def equa;r;hmt_spm;example

# Define the cellular material parameters
fem def cell;r;hmt_spm;example
fem def mate;r;n98_hmt;example cell
fem def mate;r;n98_hmt;example
fem update grid material

fem def time;r;step;example     # use these to open the L-type calcium channel ????
fem def init;r;n98_hmt;example  # use these to open the L-type calcium channel ????

# Define an explict, adaptive Adams-Moulton integration
fem def solv;r;n98_hmt;example

# Initialise the solve
fem solve to 0

# Create the history file to store the signals we want to export
fem open history;test write variables yqs niqslist $SIGNALS binary

# Loop through time
for $time (0..2)
{
	print "Time = $time\n";

  # Solve for the current time
  fem solve restart to $time

  # Write the signals to the history file
  fem write history time $time variables yqs binary
}

#  Close the history file
fem close history binary

# Generate a UnEMAP signal file
fem evaluate electrode;test history test from grid yqs iy $SIGNALS binary
		fem define export;r;hmt_spm;example
fem export signal;test electrode signal test names cell
