#Read in a 3d cube with spatially varying cellular material parameters and 
#export the parameters as a node based field.

#Set up problem size
fem define para;r;cube;example

#Define geometry of the problem
fem define coor;r;cube;example
fem define node;r;cube;example
fem define base;r;cube;example
fem define elem;r;cube;example
fem define fibr;d
fem define elem;r;cube;example fibre
fem define grid;r;cube;example
fem update grid geometry
fem update grid metric
#  Some useful groups
fem group grid external as boundary
fem group grid grid 92,93,101 as stimulus_site

#Define equation to solve
#  Define monodomain with LR2 kinetics
fem define equa;r;lr;example

#Define material properties for the problem

#  Define cellular material properties
fem define cell;r;lr;example
#    Define cell variants and spatially varying material parameters
fem define mate;r;variants;example cell
#  Define continuum material parameters
fem define mate;r;cube;example
fem update grid material

#Define continuum initial conditions
#  Set no-flux boundary condition
fem define init;r;cube;example

#Define the explicit solve, using the adams integrator
fem define solv;r;test;example

#The geometry can be exported to CMGUI via these commands
fem export node;3dcube as cube              #Export node geometry
fem export elem;3dcube as cube              #Export element geometry

#Export the cellular material parameters as a element based field
fem export element;grid as parameters field cell
