# Reads in a solution matrix (YQS) from a one dimensional fibre simulation
# and copies the 1-D fibre onto the rows of grid points in a two dimensional
# sheet.

#set the problem size
fem define para;r;spiral;example

#set up the 2-D sheet
fem define base;r;spiral;example
fem define mesh;r;spiral;example

#Export the mesh
fem export node;spiral as sheet
fem export elem;spiral as sheet

#define the FD grid
fem define grid;r;spiral;example
fem update grid geometry
fem update grid metric
fem group grid external as boundary
fem group grid xi1 low as stimulus oneoff
fem group grid square 1117 as S2

#define an ionic current model
fem define equa;r;spiral;example

#define material parameters
fem define cell;r;try_IKrblocked_S1;example
fem define mate;r;spiral_epi_M_endoS1;example cell
fem define mate;r;spiral_epi_M_endo;example
fem update grid material

#set initial conditions
fem define init;r;spiral;example

#define the solve
fem define solv;r;spiral_adaptive;example

#set the number of threads for multiprocessing
# not for examples rgb set num_threads 32

#export the cellular material parameters
fem export elem;cell_parameters field cell as sheet

#initialise the solve
### Cannot solve without the user cell model
#fem solve to 0

#read in the 1-D matrix and spread over the 2-D sheet
fem read matrix;$example."test_Ikrblocked_10beats" binary one2two

#export the potential field
fem export elem;potential field as sheet
