#Read in files
#-------------
gfx read node tissue
gfx read elem tissue
gfx read node tree
gfx read elem tree
gfx read elem tissue_95
gfx read elem tree_95

#Set up 3d window
#----------------
gfx create window 1 double_buffer
gfx modify window 1 image scene default light_model default
gfx modify window 1 image add_light default
gfx modify window 1 layout simple ortho_axes -y -z eye_spacing 0.25 width 400 height 400
gfx modify window 1 set current_pane 1
gfx modify window 1 background colour 0 0 0
gfx modify window 1 view parallel eye_point 2.5 0 -16.4462 interest_point 2.5 0 0 up_vector 0 -1 0 view_angle 40 near_clipping_plane 0.164462 far_clipping_plane 58.773 relative_viewport ndc_placement -1 1 2 2 viewport_coordinates 0 0 1 1
gfx modify window 1 overlay scene none
gfx modify window 1 set transform current_pane 1 std_view_angle 40 normal_lines no_antialias fast_transparency

#Set up default spectrum
#-----------------------
gfx modify spectrum default clear overwrite_colour
gfx modify spectrum default linear reverse range -85 15 extend_above extend_below rainbow colour_range 0 1 ambient diffuse

#Set up tissue graphics
#----------------------

# Command updated by fixcom.sh on Wed Aug 23 17:49:59 NZT 2000
# Old command: gfx modify g_element tissue general circle_discretization 6 default_coordinate default_coordinate element_discretization 4*4*4 native_discretization potential
gfx modify g_element tissue general circle_discretization 6 default_coordinate default_coordinate element_discretization "4*4*4" native_discretization potential

gfx modify g_element tissue lines material default
gfx modify g_element tissue surfaces material default data potential spectrum default

#Set up tree graphics
#--------------------

# Command updated by fixcom.sh on Wed Aug 23 17:49:59 NZT 2000
# Old command: gfx modify g_element tree general circle_discretization 6 default_coordinate default_coordinate element_discretization 4*4*4 native_discretization none
gfx modify g_element tree general circle_discretization 6 default_coordinate default_coordinate element_discretization "4*4*4" native_discretization none

gfx modify g_element tree cylinders constant_radius 0.1 material default data potential spectrum default

#Do not view axes
#----------------
gfx set vis axes off
