#Read in Geometry Information
#============================
gfx read node box
gfx read elem box

#Window Commands
#===============
gfx create window 1 double_buffer
gfx modify window 1 image scene default light_model default
gfx modify window 1 image add_light default
gfx modify window 1 layout simple ortho_axes z -y eye_spacing 0.25 width 567 height 397
gfx modify window 1 set current_pane 1
gfx modify window 1 background colour 0 0 0 texture none
gfx modify window 1 view parallel eye_point -0.257789 -4.28474 1.44091 interest_point 1.30138 0.999723 -0.271649 up_vector 0.102643 0.279126 0.954753 view_angle 33.2187 near_clipping_plane 0.057697 far_clipping_plane 20.6189 relative_viewport ndc_placement -1 1 2 2 viewport_coordinates 0 0 1 1
gfx modify window 1 overlay scene none
gfx modify window 1 set transform_tool current_pane 1 std_view_angle 40 normal_lines no_antialias fast_transparency

gfx create axes length 0.58
gfx draw axes position 1
#gfx set visibility axes off

#Material Commands
#=================
gfx create material default ambient 1 1 1 diffuse 1 1 1 emission 0 0 0 specular 0 0 0 alpha 1 shininess 0
gfx create material isosurface ambient 0.5 0.51 1 diffuse 0.5 0.5 1 emission 0.1 0.1 0.1 specular 0.1 0.1 0.1 alpha 1 shininess 0.5
gfx create material yellow diff 1 1 0 amb 1 1 0 alpha 1
gfx create material red diff 1 0 0 amb 1 0 0
gfx create material extsurf amb 0 0 0 diffuse 0.2 0.2 0.5 alpha 0.2

#Spectrum Commands
#=================
gfx modify spectrum default clear overwrite_colour
gfx modify spectrum default linear reverse range -85.004 14.567  extend_below rainbow colour_range 0 1 ambient diffuse
## Create an appropriate spectrum
## Total Min. = -90, Total Max. =  50
gfx create spectrum potential log exaggeration 3 right reverse range -90 30 rainbow colour_range 0 1 ambient diffuse 

#Drawing Commands
#================
# gfx modify g_element box general circle_discretization 6 default_coordinate default_coordinate element_discretization "12*12*12" native_discretization coordinates
# gfx modify g_element box element_points glyph point size "1*1*1" label grid_point_number use_elements cell_corners native_discretization grid_point_number invisible

#gfx modify g_element box element_points glyph cross general size "0.1*0.1*0.0" centre 0,0,0 use_elements cell_corners native_discretization grid_point_number
gfx modify g_element box element_points glyph point centre 0,0,0 use_elements cell_corners native_discretization grid_point_number

#gfx modify g_element cube lines material yellow
##gfx modify g_element cube surfaces material extsurf


#Read in next time steps
#=======================

foreach $count ('000'..'020') {
#foreach $count ('000'..'000') {
 my $time = $count / 2;
 print "time: $time\n";

 gfx read element "gridfield_$count"       #read in the field
#Field Commands
#================
gfx def field arrow_dir composit 0 0 potential.potential

# gfx modify g_element 1..2 element_points glyph arrow_solid general size "0*0.1*0.1" centre 0,0,0 orientation potential scale_factors "0.01*0*0" use_elements cell_corners discretization "1*1*1" native_discretization potential select_on material default data potential spectrum potential 

gfx create element_points glyph arrow_solid size "0.3*0.1*0.1" orientation arrow_dir scale_factors "0.01*0*0" use_elements cell_corners  native_discretization potential  material default data potential spectrum potential from box as wave time $time



#  gfx create element_points use_elements native_discretization potential glyph diamond size 0.1 cell_corners material default data potential spectrum potential from cube as wavefield time $time
# 
  gfx draw graphics_object wave
#  gfx draw graphics_object wavefield
#  gfx timekeeper default set_time $time
# #gfx print file sprintf('gridfield_%3.3d.rgb',$count) rgb
 }
# 
# # gfx set order cube
# 
 gfx timekeeper default play minimum 0 maximum 10
 gfx timekeeper default stop set_time 0
 gfx timekeeper default play speed 1
 gfx create time_editor
# 
gfx modify g_element 1..2 element_points glyph arrow_line general size "0.05*0.05*0.05" centre 0,0,0 orientation fibres scale_factors "0.2*0.1*0.1" use_elements cell_corners discretization "1*1*1" native_discretization grid_point_number select_on material default selected_material default_selected
