#Example b213a
#
# This example directly couples a circular boundary element
#  region to an annular bidomain grid region. 
#

# Set up problem regions
#  (1 grid and 1 bem)
$GRIDHT=1 
$VENTCL=2 

# Set up problem classes
#  (1 laplace and 2 bidomain)
$TMEM=1 
$BLPL=2 

# Define problem geometry
fem define para;r;torsoslice;example
fem define regi;r;torsoslice;example
fem define node;r;gridht;example  reg $GRIDHT
fem define node;r;ventcl3;example reg $VENTCL
fem define base;r;linear;example
fem define elem;r;gridht;example  reg $GRIDHT
fem define elem;r;ventcl3;example reg $VENTCL

# Generate the grid mesh
fem define grid;r;gridht;example reg $GRIDHT
fem update grid geom reg $GRIDHT
fem update grid metric reg $GRIDHT
fem group grid xi2=0 as endocardium reg $GRIDHT
fem group grid external as boundary reg $GRIDHT
fem group grid line 1 xidirn 2 as stimulus reg $GRIDHT

# Calculate the mapping from grid points to
#  boundary element nodes
fem update node grid grid_reg $GRIDHT bem_reg $VENTCL
fem update node geomet from grid reg $VENTCL

# Define the problem setup
fem define equa;r;gridht;example reg $GRIDHT class $TMEM lock
fem define equa;r;ventcl;example reg $VENTCL class $BLPL lock
fem define mate;r;ventcl;example reg $VENTCL class $BLPL
fem define mate;d reg $GRIDHT class $TMEM
fem update grid material reg $GRIDHT class $TMEM
fem define init;r;ventcl;example reg $VENTCL class $BLPL
fem define init;d reg $GRIDHT class $TMEM
fem define solv;r;gridht;example reg $GRIDHT class $TMEM
fem define solv;r;ventcl;example reg $VENTCL class $BLPL

# Solve the laplace problem
fem solve reg $VENTCL class $BLPL

# Solve the coupled bidomain problem
fem solve activ reg $GRIDHT,$VENTCL class $TMEM,$BLPL grid endocardium cptype 2

