#Example b2142
#
# This example directly couples a circular boundary element
#  region to an annular bidomain grid region. 
#

# Set up problem regions
#  (1 grid and 1 bem)
$VENTCL=1 
$GRIDHT=2 

# Set up problem classes
#  (1 laplace and 2 bidomain)
$BLPL=1 
$TMEM=2 
$EXTC=3 

# Define problem geometry
fem define para;r;torsoslice;example
fem define regi;r;torsoslice;example
fem define node;r;ventcl3;example reg $VENTCL
fem define node;r;gridht;example  reg $GRIDHT
fem define base;r;linear;example
fem define elem;r;ventcl3;example reg $VENTCL
fem define elem;r;gridht;example  reg $GRIDHT

# Generate the grid mesh
fem define grid;r;gridht;example reg $GRIDHT
fem update grid geom reg $GRIDHT
fem update grid metric reg $GRIDHT
fem group grid external as boundary reg $GRIDHT
fem group grid xi2=0 as endocardium reg $GRIDHT
fem group grid line 1 xidirn 2 as stimulus reg $GRIDHT

# Calculate the mapping from grid points to
#  boundary element nodes
fem update node grid grid_reg $GRIDHT bem_reg $VENTCL

# Adjust the boundary element node positions to align
#  exactly with the boundary collocation points - this
#  should be the case - only the refine command makes
#  them a bit different when the mesh was initially created
fem update node geomet from grid reg $VENTCL

# Define the problem setup
fem define equa;r;ventcl;example reg $VENTCL class $BLPL lock
fem define equa;r;gridht;example reg $GRIDHT class $TMEM,$EXTC lock
fem define mate;r;ventcl;example reg $VENTCL class $BLPL
fem define mate;r;gridht;example reg $GRIDHT class $TMEM,$EXTC
fem define cell;r;gridht;example reg $GRIDHT class $TMEM,$EXTC
fem update grid material reg $GRIDHT class $TMEM,$EXTC
fem define init;r;ventcl;example reg $VENTCL class $BLPL
fem define init;r;gridht;example reg $GRIDHT class $TMEM,$EXTC
fem define solv;r;gridht;example reg $GRIDHT class $TMEM
fem define solv;r;gridht;example reg $GRIDHT class $EXTC
fem define solv;r;ventcl;example reg $VENTCL class $BLPL

# Solve the laplace problem
fem solve reg $VENTCL class $BLPL

# Solve the coupled bidomain problem for 10ms
fem solve activ coupled to 10 reg $GRIDHT,$VENTCL class $TMEM,$EXTC,$BLPL grid endocardium cptype 2
