fem define parameters;r;petrov-heart;example

fem define coordinates;r;rect3D-c0;example    #3D rect. Cart. with atleast C0 continuity 
fem define bases;r;herm3;example         #tri-cubic hermite bases and others
# geometry:
fem define node;r;heart;example        #99 nodes
fem define element;r;heart;example     #60 elements
# fibres:
fem define fibre;r;heart;example
fem define element;r;heart;example fibre
# miscellaneous fields:
# 1st field is tri-cubic Hermite, used in the solution process for continuity.
# 2nd field determines versions for dep. var.
# cm does not really provide a place to specify the interpolation
# of the dependent variable (activation time in this case) so
# a scalar field (the 2nd) is set up to describe this information.
fem define field;r;c0;example
fem define element;r;c0;example field
# orthotropic eikonal equation, solved with Petrov-Galerkin FEM
fem define equation;r;eik-ort-pet;example
fem define material;r;heart;example       #material parameters
fem define initial;r;lv-free;example   #left ventricular free wall initiation
fem update field eikonal            #calculate continuity field 1
fem update gauss eikonal timing     #calculate gauss point stuff
fem define solve;r;eik-an;example      #analytical derivatives for Newton method
# A continuation method is used here to use a linear (diffusion) problem to
# provide an initial guess of the solution to a non-linear problem
# (eikonal-diffusion).  When the increment parameter is 0 there is no eikonal
# term in the equation.  When the parameter is 1 then the equation is the full
# non-linear problem.  In-between the non-linear term is smaller.

# iterate 1 is specified during the continutation process so as to only do one
# iteration in the Newton method at each step as an accurate solution is only
# required in the final solve.

fem solve iterate 1 increment 0.01; # one iteration with 100x diffusion
if( $TESTING )
  { # check application of boundary conditions
    fem define initial;w;lv-free-iter1
  }

if( 0 )
  { # skip gradual reduction in diffusion to save some time
    fem solve iterate 1 increment 0.03;
    fem solve iterate 1 increment 0.07;
    fem solve iterate 1 increment 0.1;
    fem solve iterate 1 increment 0.14;
    fem solve iterate 1 increment 0.2;
    fem solve iterate 1 increment 0.3;
    fem solve iterate 1 increment 0.4;
    fem solve iterate 1 increment 0.5;
    fem solve iterate 1 increment 0.7;
    # fem solve increment 0.7
    # fem define initial;w;lv-free-0.7;example
  } else
  { # Read in precalculated solution at 1.4x diffusion
    fem define initial;r;lv-free-0.7;example;
  }

fem solve iterate 1 increment 0.8         #one iteration with 1.25x diffusion
fem solve iterate 1 increment 0.9         #one iteration with 1.1x diffusion
fem solve increment 1                     #solve with correct diffusion

fem export node;heart as heart
fem export elem;heart as heart
fem export node;heart-sol field as heart_sol
fem export elem;heart-sol field as heart_sol

if( $TESTING )
  {
    fem list node;solution solution
  }
