fem define parameter;r;r23;example;

fem define coordinate;r;rc3d;example;   # 3D rectangular Cartesian coordinates
fem define node;r;heart-mr3;example;    # 130 nodes
fem define base;r;hermite3;example;     # tri-cubic hermite bases and others
fem define element;r;heart-mr3;example; # 90 tricubic-Hermite elements
fem define fibre;r;heart-mr3;example;   #fibres
fem define element;r;heart-mr3;example fibre;
fem refine xi 2 cross;                  # refine in xi 2 direction
# Remove unnecessary versions from internal nodes where fields should be
# continuous.
FEM update node continuous_internal;

# Remove the confusion of scale factors.
# (Also allows the same bases to be used for field 1.)
fem update scale unit;

# Define 2 fields used in the solution:
#   Field 1 is tri-cubic Hermite (unit scalefactors) and will be set to
#     zero where dep. var. is not C1 continuous.
#   Field 2 determines versions for dep. var.
FEM define field;r;r23;example;
FEM define element;r;r23;example field;

# Orthotropic eikonal, Petrov-Galerkin FEM
fem define equation;r;eik-ort-pet;example;

# Set up groups for the various regions of the tissue that have different
# material properties.
fem group element 1,2,9..12,19,20,91,92,101,102,109,110 as purk-rf;
fem group element 62,71,72,79,80,161,162,169,170 as purk-rs;
fem group element 33..38,41..60,131..138,141..150 as purk-lv;
fem group element 99..100 as rest-rf;
fem group element 61,69..70,151,152,159..160 as rest-rs;
fem group element 31..32,39..40,121..132,139..140 as rest-lv;
fem group node xi3=0 element purk-rf as purk-rf;
fem group node xi3=1 element purk-rs as purk-rs;
fem group node xi3=0 element purk-lv as purk-lv;
fem group node purk-lv as purkinje;
fem group node xi3=0 element rest-rf as rest-rf;
fem group node xi3=1 element rest-rs as rest-rs;
fem group node xi3=0 element rest-lv as rest-lv;
fem group node purk-rf,purk-rs,rest-rf,rest-rs,rest-lv as endo;
fem group node 1..256 as all;
fem def material;r;myocardium-penet;example;
fem def initial;r;myocardium-purkinje-r23;example;

#fem update field from solution to 2
fem update field eikonal;               #calculate continuity field 1

# Precalculate guass point invariants
fem update gauss eikonal timing;

fem def solve;r;gmres;example;

if( 0 )
  { # skip gradual reduction in diffusion to save some time
    fem solve iterate 1 increment 0.02;
    fem solve iterate 1 increment 0.05;
    fem solve iterate 1 increment 0.07;
    fem solve iterate 1 increment 0.1;
    fem solve iterate 1 increment 0.15;
    fem solve iterate 1 increment 0.2;
    fem solve iterate 1 increment 0.25;
    fem solve iterate 1 increment 0.3;
    fem solve iterate 1 increment 0.35;
    fem solve iterate 1 increment 0.4;
    fem solve iterate 1 increment 0.45;
  }

# Twice the physiological level of diffusion is required to keep the solution
# stable.

# Read in precalculated solution
fem def initial;r;myocardium-purkinje-r23-a.5;example;
# Check that this is still the solution
fem solve iterate 2 increment 0.5;

if( $TESTING )
  {
    fem def initial;w;myocardium-purkinje-r23-a.5
  }

# Output results for cmgui
fem export node;heart as heart
fem export elem;heart as heart
fem export elements;purkinje field as heart
fem export nodes;penet-a.5 field as heart
