#! /bin/tcsh
#
# Shell file to take the CMISS ppm frames, crop them, flip them,
# combine them, and convert them to an rgb file ready for the creation
# of a movie
#
# Usage: 
#   convertframes.sh 
#
# Created: 
#   Chris Bradley, 29 September 1998
#
# Updates: 
#

foreach file ( *.ppm )
	echo "Converting file "${file}
	convert -crop 170x99+21+11 ppm:${file} ppm:tmp1.ppm
	convert -flip ppm:tmp1.ppm ppm:tmp2.ppm
	montage -frame +0+0 -geometry +0+0 -tile 1x2 ppm:tmp1.ppm ppm:tmp2.ppm ppm:tmp3.ppm
	convert ppm:tmp3.ppm sgi:${file:s%ppm%rgb%}
	rm tmp1.ppm tmp2.ppm tmp3.ppm
end

