#Example_b35 6*5 coupled electromechanics 
#- case setup for Peter Kohl to test stretch-activated channel causing reentry. 
#
# Set up problem type definitions
$MECHANICS = 1
$ELECTRICS = 2
 
# Set up the geometry 4x4 elem 32*32mm bilinear basis
fem define para;r;emech;example 

fem define node;r;emech-6x5;example 
fem define base;r;emech;example 
fem define elem;r;emech-6x5;example 
fem define fibr;r;emech-0;example       #fibre angles =0
fem define elem;r;emech-6x5;example  fibre
fem define window;r;emech;example

# Set up the mechanics
fem define equa;r;mech;example class $MECHANICS lock
fem define mate;r;mech1;example #elem 3 has 10x lower k11  
fem group nodes 1,8,15,22,29,36  as LH_bdy_nodes
fem group nodes 7,14,21,28,35,42 as RH_bdy_nodes
fem group node external as bdy_nodes
fem define init;r;mech;example 
fem define solv;r;mech;example 
fem define acti;r;mech;example 

# Set up the electrical activation
fem define grid;r;elec-9x9;example class $ELECTRICS
fem update grid geometry
fem update grid metric
fem group grid external as boundary
fem group grid element 3 as infarct
fem define equa;r;elec-vcd;example class $ELECTRICS
fem define mate;r;elec-vcd7;example class $ELECTRICS
fem define cell;r;elec-vcd7;example class $ELECTRICS
fem update grid material class $ELECTRICS
fem group grid xi1=0 oneoff as lhs_line
fem define init;r;elec-lhs_line;example class $ELECTRICS
fem define solv;r;elec;example class $ELECTRICS
fem solve class $ELECTRICS to 0

# Solve the coupled equations (for this test example the hundreds loop is omitted)
for $time ( 0..1 ) 
{
  fem solve class $ELECTRICS restart to $time

  #fem update gauss calcium from_class ELECTRICS
  fem update gauss calcium from_class $ELECTRICS infarct 3 #zero Ca in elem 3
  #fem list activ full
  fem solve class $MECHANICS incr 0. iter 99
  #fem list strain elem 3 extrem
  fem update grid geom deformed class $ELECTRICS from_class $MECHANICS
  #fem update grid metric deformed class ELECTRICS from_class MECHANICS
  fem update grid material class $ELECTRICS
  fem update grid strain class $ELECTRICS
  #fem list grid class ELECTRICS yq grid infarct 
  fem draw field grid 1 class $ELECTRICS zmin=-100 zmax=100 noscale
  fem draw lines deformed rgb=white
  fem draw fibre deformed rgb=black
  refresh graphics
  #fem gxprint;step//HUN//TEN//UNIT;example portable_pix_map height=220 width=220
}
