C Program sets grid point values for groups i=1..Ngroups specified in 
C POINTS(j,i),j=1..NPTS(i) to values specified in VALUES(i).

      IMPLICIT NONE
      REAL*8 VALUE,VALUES(9),Fibre_conductivity,Sheet_conductivity
      INTEGER i,j,DIGIT,gridpt,NPTS(9),Ngroups,POINTS(100,9)
      LOGICAL continue,FOUND
      CHARACTER STRING*60,CONDUCTIVITY*5
      DATA Ngroups/4/                                      !#groups
      DATA NPTS/33,21,25,25,5*0/                        !#pts in each group
      DATA POINTS/155,156,157,158,159,                     !group 1 row 1
     '            163,164,165,166,167,                     !group 1 row 2
     '            171,172,173,174,175,                     !group 1 row 3
     '            179,180,181,182,183,                     !group 1 row 4
     '            187,188,189,190,191,                     !group 1 row 5
     '            195,196,197,198,199,                     !group 1 row 6
     '                204,205,206,                         !group 1 row 7
     '            67*0,
     '            154,162,170,178,186,194,202,             !group 2 LH side
     '            160,168,176,184,192,200,208,             !group 2 RH side 
     '            211,212,213,214,215,                     !group 2 top
     '            203,207,                                 !group 2 corners
     '            79*0,
     '             89, 97,105,113,121,129,137,145,         !group 3 LH side
     '            161,169,177,185,193,201,209,217,         !group 3 RH side
     '            218,219,220,221,222,223,224,             !group 3 top
     '            210,216,                                 !group 3 corners
     '            75*0,
     '             88, 96,104,112,120,128,136,144,         !group 4 LH side
     '            226,234,242,250,258,266,274,282,         !group 4 RH side
     '            578,579,580,581,582,583,584,             !group 4 top
     '            153,225,                                 !group 4 corners
     '            75*0,
     '            500*0/ !points
!           group  (1)     (2)    (3)    (4)    
!     DATA VALUES/0.5e-4,  1.e-4, 2.e-4, 5.e-4, 5*0/
      DATA VALUES/ 1.e-4,  5.e-4, 7.e-4, 9.e-4, 5*0/
      DATA Fibre_conductivity/10.e-4/,Sheet_conductivity/5.e-4/
    
! Read from grid1 file
      OPEN(unit=1,file='grid1.ipmate')
      OPEN(unit=2,file='grid2.ipmate')
      CONDUCTIVITY='NULL '
      continue=.true.

      DO WHILE (continue)
        READ(1,'(A)',END=100) STRING(1:60)
        
        IF(STRING(2:24).EQ.'Int. conductivity-fibre') THEN
          CONDUCTIVITY='FIBRE'
        ELSE IF(STRING(2:24).EQ.'Int. conductivity-sheet') THEN
          CONDUCTIVITY='SHEET'
        ENDIF
        WRITE(*,'('' Conductivity = '',A)') CONDUCTIVITY
        IF(STRING(2:19).EQ.'The value for grid') THEN
          IF(STRING(23:24).EQ.'is') THEN      !1 digit number
            DIGIT=1
            READ(STRING(21:21),'(I1)') gridpt
            READ(STRING(39:50),'(E12.4)') VALUE
          ELSE IF(STRING(24:25).EQ.'is') THEN !2 digit number
            DIGIT=2
            READ(STRING(21:22),'(I2)') gridpt
            READ(STRING(40:51),'(E12.4)') VALUE
          ELSE IF(STRING(25:26).EQ.'is') THEN !3 digit number
            DIGIT=3
            READ(STRING(21:23),'(I3)') gridpt
            READ(STRING(41:52),'(E12.4)') VALUE
          ELSE IF(STRING(26:27).EQ.'is') THEN !4 digit number
            DIGIT=4
            READ(STRING(21:24),'(I4)') gridpt
            READ(STRING(42:53),'(E12.4)') VALUE
          ENDIF
          WRITE(*,'('' grid pt='',I6,'' value = '',E12.5)') 
     '      gridpt,VALUE
          FOUND=.false.
          i=0 !loop over groups
          DO WHILE(.NOT.FOUND.AND.i.LT.Ngroups)
            i=i+1
            j=0 !loop over pts in group i
            DO WHILE(.NOT.FOUND.AND.j.LT.NPTS(i))
              j=j+1
              IF(gridpt.EQ.POINTS(j,i)) THEN
                FOUND=.true.
                IF(CONDUCTIVITY.EQ.'FIBRE') THEN
                  VALUE=VALUES(i)
                ELSE IF(CONDUCTIVITY.EQ.'SHEET') THEN
                  VALUE=0.5*VALUES(i) !sheet conduct.y = 0.5* fibre conduct.y 
                ENDIF
                WRITE(*,'('' Grid pt '',I6,'' in group '',I2,'
     '            //''' has new value'',E12.4)') 
     '            gridpt,i,VALUE
              ENDIF
            ENDDO !while .not.found
          ENDDO !i

          IF(FOUND) THEN
            IF(DIGIT.EQ.1) THEN
              WRITE(2,'(A,E12.4)') STRING(1:38),VALUE
            ELSE IF(DIGIT.EQ.2) THEN
              WRITE(2,'(A,E12.4)') STRING(1:39),VALUE
            ELSE IF(DIGIT.EQ.3) THEN
              WRITE(2,'(A,E12.4)') STRING(1:40),VALUE
            ELSE IF(DIGIT.EQ.4) THEN
              WRITE(2,'(A,E12.4)') STRING(1:41),VALUE
            ENDIF
          ELSE 
            IF(CONDUCTIVITY.EQ.'FIBRE') THEN
              VALUE=Fibre_conductivity
            ELSE IF(CONDUCTIVITY.EQ.'SHEET') THEN
              VALUE=Sheet_conductivity
            ENDIF
            IF(DIGIT.EQ.1) THEN
              WRITE(2,'(A,E12.4)') STRING(1:38),VALUE
            ELSE IF(DIGIT.EQ.2) THEN
              WRITE(2,'(A,E12.4)') STRING(1:39),VALUE
            ELSE IF(DIGIT.EQ.3) THEN
              WRITE(2,'(A,E12.4)') STRING(1:40),VALUE
            ELSE IF(DIGIT.EQ.4) THEN
              WRITE(2,'(A,E12.4)') STRING(1:41),VALUE
            ENDIF
          ENDIF !found

        ELSE 
          WRITE(2,'(A)') STRING(1:60)
        ENDIF !string
      ENDDO !while continue

 100  CLOSE(unit=1)
      CLOSE(unit=2)

      STOP
      END
        
