#Example_b35 6*5 coupled electromechanics with solution 
#
# Set up problem type definitions

# Command updated by fixcom.sh on Wed Aug 23 17:50:18 NZT 2000
# Old command: assign variable MECHANICS 1
$MECHANICS = 1


# Command updated by fixcom.sh on Wed Aug 23 17:50:18 NZT 2000
# Old command: assign variable ELECTRICS 2
$ELECTRICS = 2

 
# Set up the geometry 4x4 elem 32*32mm bilinear basis
fem define para;r;emech 

fem define node;r;emech-6x5 
fem define base;r;emech 
fem define elem;r;emech-6x5 
fem define fibr;r;emech-0       #fibre angles =0
fem define elem;r;emech-6x5  fibre
fem define window;r;emech

# Set up the mechanics
fem define equa;r;mech class $MECHANICS lock
fem define mate;r;mech1 #elem 3 has 10x lower k11  
fem group nodes 1,8,15,22,29,36  as LH_bdy_nodes
fem group nodes 7,14,21,28,35,42 as RH_bdy_nodes
fem group node external as bdy_nodes
fem define init;r;mech 
fem define solv;r;mech 
fem define acti;r;mech 

# Set up the electrical activation
fem define equa;r;elec-vcd class $ELECTRICS
fem define grid;r;elec-9x9 class $ELECTRICS
fem update grid geometry
fem update grid metric
fem group grid external as boundary
fem group grid element 3 as infarct
fem define mate;r;elec-vcd8 class $ELECTRICS
fem update grid material class $ELECTRICS
fem group grid xi1=0 oneoff as lhs_line
fem define init;r;elec-lhs_line class $ELECTRICS
fem define solv;r;elec class $ELECTRICS #time step is 0.01s
fem define;add base;r;quadbasis 
fem solve class $ELECTRICS to 0

# Solve the coupled equations

# Command updated by fixcom.sh on Wed Aug 23 17:50:18 NZT 2000
# Old command: DO HUN=0..0
for $HUN ( 0..0 ) 
{


# Command updated by fixcom.sh on Wed Aug 23 17:50:18 NZT 2000
# Old command: DO TEN=0..9
for $TEN ( 0..9 ) 
{


# Command updated by fixcom.sh on Wed Aug 23 17:50:18 NZT 2000
# Old command: DO UNIT=0..9
for $UNIT ( 0..9 ) 
{


# Command updated by fixcom.sh on Wed Aug 23 17:50:18 NZT 2000
# Old command: DO DEC1=0..9
for $DEC1 ( 0..9 ) 
{

#fem solve class ELECTRICS restart to HUN//TEN//UNIT//.//DEC1
fem solve class $ELECTRICS restart for 0.999 #solve for 1ms increment
#fem update gauss calcium from_class ELECTRICS
fem update gauss calcium from_class $ELECTRICS infarct 3
#fem list activ full
fem solve class $MECHANICS incr 0. iter 99
#fem list strain elem 3 extrem
fem update gauss deformed_fibres collocation
fem update grid geom deformed class $ELECTRICS from_class $MECHANICS
#fem update grid metric deformed class ELECTRICS from_class MECHANICS
fem update grid material class $ELECTRICS
fem update grid strain class $ELECTRICS SAC_ext 1.1 SAC_scale 1.0
fem list grid class $ELECTRICS yq grid infarct
fem list grid class $ELECTRICS yq grid 15
fem draw field grid 1 class $ELECTRICS zmin=-100 zmax=55 noscale
fem draw lines deformed rgb=white
#fem draw fibre deformed rgb=black
refresh graphics
#IF DEC1=0

# Command updated by fixcom.sh on Wed Aug 23 17:50:18 NZT 2000
# Old command:   print;step//$HUN//$TEN//$UNIT//$DEC1 portable_pix_map height=220 width=220
fem gxprint;step${HUN}${TEN}${UNIT}$DEC1 portable_pix_map height=220 width=220

#ENDIF

# Command updated by fixcom.sh on Wed Aug 23 17:50:18 NZT 2000
# Old command: ENDDO
}



# Command updated by fixcom.sh on Wed Aug 23 17:50:18 NZT 2000
# Old command: ENDDO
}



# Command updated by fixcom.sh on Wed Aug 23 17:50:18 NZT 2000
# Old command: ENDDO
}



# Command updated by fixcom.sh on Wed Aug 23 17:50:18 NZT 2000
# Old command: ENDDO
}



define macro s "read com;step" #defines macro 's' for single step 
