#Example_b4 6*5 setup coupled electromechanics 
#
# Set up problem type definitions

# Command updated by fixcom.sh on Wed Aug 23 17:50:17 NZT 2000
# Old command: assign variable MECHANICS 1
$MECHANICS = 1


# Command updated by fixcom.sh on Wed Aug 23 17:50:17 NZT 2000
# Old command: assign variable ELECTRICS 2
$ELECTRICS = 2

 
# Set up the geometry 4x4 elem 32*32mm bilinear basis
fem define para;r;emech 

fem define node;r;emech-6x5 
fem define base;r;emech 
fem define elem;r;emech-6x5 
fem define fibr;r;emech-0              #fibre angles = 0deg
fem define elem;r;emech-6x5  fibre
fem define wind;r;emech

# Set up the mechanics
fem define equa;r;mech class $MECHANICS lock
fem define mate;r;mech1 #elem 14 has 10x lower k11 
fem group nodes 1,8,15,22,29,36  as LH_bdy_nodes
fem group nodes 7,14,21,28,35,42 as RH_bdy_nodes
fem group node external as bdy_nodes
fem define init;r;mech 
fem define solv;r;mech 
fem define acti;r;mech 

# Set up the electrical activation
fem define equa;r;elec-vcd class $ELECTRICS
fem define grid;r;elec-9x9 class $ELECTRICS
fem update grid geometry
fem update grid metric
fem group grid external as boundary
fem group grid element 14 as infarct
fem define mate;r;elec-vcd8 class $ELECTRICS
fem update grid material class $ELECTRICS
fem group grid xi1=0 oneoff as lhs_line
fem define init;r;elec-lhs_line class $ELECTRICS
fem define solv;r;elec class $ELECTRICS
fem define;add base;r;quadbasis 
#fem solve class ELECTRICS to 0

#fem draw field grid 1 class ELECTRICS zmin=-100 zmax=50 noscale
#fem draw lines deformed rgb=white
#fem draw fibre deformed rgb=black
fem

define macro s "read com;step" #defines macro 's' for single step 

