#Example_c2 Solving for potential in the skull

            #This example solves for the potential on the surface of
            #the skull due to an arbitrary dipole placed inside the
            #skull.  Note that this problem requires a large parameter
            #set for CMISS. A suitable parameters.inc file is given in
            #the example directory for this example.

#Calculate the potential on the skull
fem                            #Sets the environment to FEM.
fem define parameter;r;skull_potential;example  #sets up parameters

fem define coordinates;r;;example  #defines 3D rectangular.
fem define bases;r;;example        #Define 1 bicubic Hermite BEM basis.
fem define nodes;r;;example        #Define the geometry.
fem define elements;r;;example          
fem define equation;r;;example     #Standard laplace equation.
fem define material;r;;example     #No material definition.
fem define source;r;;example       #Define an arbitrary dipole position,
#                              !  orientation and strength.
fem define initial;r;;example      #Fix the potential at the top of the
#                              !  skull to 0.0.
fem define solve;r;;example        #Define solution parameters.
fem solve                      #Calculate the potential on the skull.
fem export elem;skull_geometry as full_skull #export the geometry
#                              !  of the skull to CMGUI.
fem export node;skull_geometry as full_skull
fem export node;skull_potential as full_skull field #Export the 
#                              !  potential to CMGUI.
fem export elem;skull_potential as full_skull field
