#View the potential
#-------------------------------------
# Read in node and element information
#------------------------------------- 
gfx read node skull_geometry
gfx read element skull_geometry
gfx read node skull_potential
gfx read element skull_potential

#--------------------------------
# Create and set up the 3d window
#--------------------------------
gfx create window 1 double_buffer
gfx modify window 1 image scene default light_model default
gfx modify window 1 image add_light default
gfx modify window 1 layout simple ortho_axes z -y eye_spacing 0.25 width 400 height 400
gfx modify window 1 set current_pane 1
gfx modify window 1 background colour 0 0 1
gfx modify window 1 view parallel eye_point -322.776 375.372 -172.161 interest_point 84.7918 -0.217667 -0.59061 up_vector 0.236801 -0.179229 -0.954883 view_angle 34.813 near_clipping_plane 5.80186 far_clipping_plane 2073.39 relative_viewport ndc_placement -1 1 2 2 viewport_coordinates 0 0 1 1
gfx modify window 1 overlay scene none
gfx modify window 1 set transform current_pane 1 std_view_angle 40 perturb_lines no_antialias fast_transparency

#---------------------
# Do not show the axes
#---------------------
gfx set vis axes off

#----------------------------------------
# Create materials for the bone and lines
#----------------------------------------
gfx create material bone ambient 0.5 0.5 0.5 diffuse 1 0.92 0.67 emission 0 0 0 specular 0.87 0.85 0.92 alpha 1 shininess 0.85
gfx create material line ambient 1 1 1 diffuse 0 0 0 emission 0 0 0 specular 0 0 0 alpha 1 shininess 0

#------------------------------------------
# Modify the spectrum to include all values
#------------------------------------------
gfx modify spectrum default clear overwrite_colour
gfx modify spectrum default linear reverse range -0.0537792 0.0599177 extend_above extend_below rainbow colour_range 0 1 ambient diffuse

#-----------------------------------------------------
# Add surfaces with a potential scalar and black lines
#-----------------------------------------------------

# Command updated by fixcom.sh on Wed Aug 23 17:50:19 NZT 2000
# Old command: gfx modify g_element full_skull general circle_discretization 6 default_coordinate default_coordinate element_discretization 5*5*5 native_discretization none
gfx modify g_element full_skull general circle_discretization 6 default_coordinate default_coordinate element_discretization "5*5*5" native_discretization none

gfx modify g_element full_skull lines material line
gfx modify g_element full_skull surfaces material bone data potential spectrum default
