#
# start of testing
#


#
# Evaluate the rereferenced
#  signals at each node
#
fem eval elect;fitted_node_reref hist fitted_reref from node bin reg 1
fem li sign bin sign fitted_node_reref
fem def export;r;nodes;example
fem export sig;fitted_node_reref elec signal fitted_node_reref
fem export node;reref hist fitted_reref bin node 335..501 as skin reg 1
fem export elem;reref field elements 721..900 region 1 as skin


#
# Evaluate the rereferenced
#  signals at each electrode
#
fem def data;r;projected_positions;example region 1
fem def xi;r;projections;example region 1
fem eval elect;fitted_reref hist fitted_reref from data bin reg 1
fem li sign bin sign fitted_reref
fem define export;r;electrodes;example
fem export signal;fitted_reref electrodes signal fitted_reref


#
# Define and read the transfer
#  matrix to transfer signals
#  from the brain to the skin
#  surface
#
fem def transfer;r;head;example
fem evaluate transfer;head SVD
fem write matrix;head matr T_BH
fem write matrix;head matr T_BH binary
fem read matrix;head T_BH binary


#
# Define and apply the
#  procedure to invert the 
#  transfer matrix
#
fem def inverse;r;head;example
fem evaluate inverse;head SVD
fem apply inverse history infile fitted_reref outfile inverse_fitted bin


#
# Export signals to CMGUI
#
fem export node;inv_pot hist inverse_fitted bin node 1..167 as brain reg 2
fem export elem;inv_pot field elements 181..360 region 2 as brain


#
# Evaluate and export signals
#  to UNEMAP
#
fem eval elect;brain history inverse_fitted from nodes bin coupled reg 2
fem def export;r;brain;example
fem export signal;brain electrodes signal brain


#
# Apply the Forward
#  Procedure to obtain signals
#  on the skin
#
fem apply transfer history infile inverse_fitted outfile trans_fitted binary


#
# Export surfaces to CMGUI
#
fem export node;trans_pot hist trans_fitted bin node 335..501 as skin reg 1
fem export elem;trans_pot field elements 721..900 region 1 as skin


#
# Evaluate and export signals
#  to UNEMAP
#
fem eval elect;trans_head hist trans_fitted from nodes binary coupled reg 1
fem def export;r;nodes;example 
fem export signal;trans_head electrodes signal trans_head


#
# Evaluate the new transformed
#  fitted signals at each
#  electrode on the scalp
#
fem def data;r;projected_positions;example region 1
fem def xi;r;projections;example region 1
fem eval elect;trans_head_data hist trans_fitted from data binary reg 1
fem li sign bin sign trans_head_data


#
# Export signals to UNEMAP
#
fem def export;r;electrodes;example
fem export signal;trans_head_data electrodes signal trans_head_data


