# If the example path is not set, default to current directory
if (! defined $example) {
    $example = "./";
}
# Drop off the trailing / in the example path
$chopped = chop $example;
if ($chopped ne "/") {
    $example .= $chopped;
}

fem define parameters;r;$example/cellml;
fem define node;d;
fem define bas;d;
fem define elem;d;
fem define grid;d;
fem update grid geometry;
fem update grid metric;
fem define equation;r;$example/cellml;
fem define cell;r;$example/difrancesco_noble_model_1985;
fem define material;d cell;
fem define material;d;
fem update grid material;
fem define initial;d;
fem define solve;r;$example/lsoda;
fem solve to 0;
fem open history;difrancesco_noble_model_1985 write variables yqs niqslist 1..35 binary;
$Tend = 5500;
$dt = 10.0;
for ($time=0;$time<$Tend;$time+=$dt) {
    fem solve restart to $time;
    fem write history time $time variables yqs binary;
}
fem close history binary;
fem evaluate electrode;difrancesco_noble_model_1985 history difrancesco_noble_model_1985 from grid yqs iy 1..35 binary;
fem define export;r;$example/difrancesco_noble_model_1985;
fem export signal;difrancesco_noble_model_1985 electrodes signal difrancesco_noble_model_1985 names cell;

# For testing we compare the generated CMISS signal files
if ($TESTING) {
    fem compare signal;difrancesco_noble_model_1985 basis both masterfile $example/difrancesco_noble_model_1985 comparefile difrancesco_noble_model_1985 binary;
}
