# Example e31 
# -----------
#


#----------------------------------------------------------#
#
# 3D time dependent torso problem
# This example shows a heart in a torso with a moving 
# dipole inside the heart -ie "quasistatic" 3d.  The 
# dipole path was obtained from Green Lane Hospital VCG.
#
#----------------------------------------------------------#


fem def para;r;torsotimedep;example          #Sets up parameters for this prob.
fem def regi;r;torsotimedep;example          #Defines two regions.
fem def coor 3,1
fem def node;r;;example region all           #Defines 291 nodes.
fem def base;r;;example                      #Defines 3 types of basis function.
fem def elem;r;;example region all           #Defines 304 elements.


#
#----------------------------#
# Export geometry
#----------------------------#
#
fem export node;hearttorso as hearttorso
fem export elem;hearttorso as hearttorso


#
#----------------------------#
# Setup equations
#----------------------------#
#
fem def equa;r;torsotimedep;example region all
#                                            #Defines a quasistatic analysis of
#                                            # the standard Laplace equation.
fem def mate;r;;example region all
fem def init;r;;example region all
fem def sour;r;;example region 2             #Defines the dipole path.
fem list source region 2
fem def coup;r;;example
fem def solv;r;;example coupled region all
fem solve coupled
