# Example e33
# -----------
#


# Inputs
#

# Command updated by fixcom.sh on Wed Aug 23 17:50:24 NZT 2000
# Old command: assign variable INPUT refinedheart
$INPUT = "refinedheart"


# Command updated by fixcom.sh on Wed Aug 23 17:50:24 NZT 2000
# Old command: assign variable FITREG 3
$FITREG = 3



# Grouping specific nodes
#

# Command updated by fixcom.sh on Wed Aug 23 17:50:24 NZT 2000
# Old command: assign variable EPIDATA    1..13,38..55,85..93:2,90..108:2,105,107,109,111,113..123
$EPIDATA = "1..13,38..55,85..93:2,90..108:2,105,107,109,111,113..123"


# Command updated by fixcom.sh on Wed Aug 23 17:50:24 NZT 2000
# Old command: assign variable LVENDODATA 25..36,37,56..73,124..153 
$LVENDODATA = "25..36,37,56..73,124..153"


# Command updated by fixcom.sh on Wed Aug 23 17:50:24 NZT 2000
# Old command: assign variable RVENDODATA 14,15,16..24,74..84,86,88,95..103,110,112,154..159
$RVENDODATA = "14,15,16..24,74..84,86,88,95..103,110,112,154..159"



fem def para;r;fitting;example
fem def regi;r;three;example
fem def coor 3,1
fem def base;r;bilinear;example
fem def node;r;$INPUT;example reg all
fem def elem;r;$INPUT;example reg all
fem list regi;regions reg all


#
#----------------------------#
# Export geometry
#----------------------------#
#
fem export node;pigheart as heart reg all
fem export elem;epi as epi reg 3
fem export elem;rvendo as rvendo reg 2
fem export elem;lvendo as lvendo reg 1


#
#----------------------------#
# Projections of all data onto 
#  all 3 surfaces
#----------------------------#
#
#fem def data;r;tricub_heart
#fem def xi;c closest reg 3
#fem export data;tricub_heart as tricub_heart error offset 10000
#fem export data;epi_data as epi_data error number EPIDATA offset 20000


#
#----------------------------#
# Projections of epi data onto 
#  all 3 surfaces
#----------------------------#
#
#fem def data;r;epi
#fem def xi;c closest reg 3
#fem def xi;w;epi reg 3
#fem def data;c from_xi
#fem export data;epi_xi as epi_xi offset 30000


#fem export data;lvendo_data as lvendo_data error number LVENDODATA offset 40000
#fem export data;rvendo_data as rvendo_data error number RVENDODATA offset 50000


#
#----------------------------#
# Projections of lvendo data 
#  onto the lvendo surface
#----------------------------#
#
#fem def data;r;lvendo
#fem def xi;c closest reg 1
#fem def xi;w;lvendo reg 1
#fem export data;lvendo_data as lvendo_data error offset 60000


#fem def data;c from_xi 
#fem export data;lvendo_xi as lvendo_xi offset 70000


#
#----------------------------#
# Projections of rvendo data 
#  onto the rvendo surface
#----------------------------#
#
#fem def data;r;rvendo
#fem def xi;c closest reg 2
#fem def xi;w;rvendo reg 2
#fem export data;rvendo_data as rvendo_data error offset 80000


#fem def data;c from_xi 
#fem export data;rvendo_xi as rvendo_xi offset 90000


#
#----------------------------#
# Define fields to fit to
#----------------------------#
#
fem def field;r;refined_heart ;example reg $FITREG
fem def elem;r;refined_heart;example field reg $FITREG
#fem def field;w;refined_heart reg FITREG
#fem def elem;w;refined_heart field  reg FITREG


#
#----------------------------#
# Final set of data with 
#  activations and xi locations
#----------------------------#
#
fem def data;r;full_activ;example field reg $FITREG
#fem def xi;c close reg 3
#fem def xi;w;bob reg 3


fem def xi;r;full;example reg $FITREG
fem export data;full as full error reg $FITREG offset 100000


