

#
# Sets up default colours and axes visualisation
#

gfx cre mat dred     diff 1.0 0.0 0.0 spec 0.6 0.3 0.3 shin 1.0
gfx cre mat dblue    diff 0.0 0.1 1.0 spec 0.4 0.4 0.5 shin 0.5 
gfx cre mat green    diff 0.0 1.0 0.0 alpha 0.9
gfx cre mat dgreen   diff 0.0 0.5 0.0 spec 0.4 0.4 0.5 shin 0.5 

gfx cre mat purple   diff 0.5 0.0 0.8 spec 0.4 0.5 0.0 shin 1.0 alp 0.9 
gfx cre mat skin     diff 0.9 0.7 0.5 spec 0.2 0.2 0.2 shin 0.1 alph 0.7
gfx cre mat beige    diff 1.0 0.8 0.7 spec 1.0 0.6 0.6 shin 1.0
gfx cre mat ghost    diff 0.6 0.6 0.6 alpha 0.16 
gfx cre mat dgrey    diff 0.2 0.2 0.2 

gfx create axes length 60 material green
gfx draw axes

gfx read node pig
gfx read elem heart
#gfx read elem lungs
gfx read elem lvendo
gfx read elem rvendo
gfx read elem skin


# Hide redundant parts
#
#gfx mod g_elem lungs  surf mat beige
#gfx mod g_elem heart  surf mat red
#gfx mod g_elem rvendo surf mat dblue
#gfx mod g_elem lvendo surf mat dgreen
gfx set vis skin



# Create spectrums
#
gfx cre spec pot
gfx mod spec pot min -0.14 max .10

gfx cre spec act
gfx mod spec act min 0 max 50


# Torso Potentials
#
gfx read node /usr/tmp/cheng/activ_trsf/forward_01_1014
gfx read elem /usr/tmp/cheng/activ_trsf/forward_01
gfx mod g_elem soln surf data potential spectrum pot
gfx mod g_elem soln lines mat dgrey


# Creating child scene
#
gfx cre scene bob g_elem add_light default
gfx draw child bob scene default

gfx set transf name soln scene bob  -1 0 0 0   0 -1 0 0   0 0 1 0   420 -150 0 1
gfx mod g_elem soln surface data potential spectrum pot scene bob
gfx mod g_elem soln lines mat dgrey scene bob
gfx set vis axes off scene bob

# Create windows & get the correct view
#
gfx set vis axes off
gfx cre win 1
gfx mod win 1 image view
gfx mod win 1 set slow
gfx mod win 1 set pert
gfx mod win 1 background colour 0 0 0 all

gfx modify window 1 layout simple width 488 height 366
gfx modify window 1 view eye 211 -1323 -88 interest 211 -87 -88


#
# Activation on Heart
#
gfx read node activ
gfx read elem activ_epi
gfx read elem activ_vendo

gfx mod g_elem activ_epi lines mat dgrey
gfx mod g_elem activ_epi surf data activ spectrum act
gfx mod g_elem activ_vendo lines mat dgrey
gfx mod g_elem activ_vendo surf data activ spectrum act

gfx set tran nam activ_vendo 1 0 0 0  0 1 0 0  0 0 1 0  200 0 -150  1
gfx set tran nam activ_epi   1 0 0 0  0 1 0 0  0 0 1 0  200 0    0  1


# Create some text
#
gfx cre scene overlay
gfx mod scene overlay add_light default
gfx set vis axes off scene overlay
gfx mod win 1 overlay scene overlay

gfx cre annotation position -.8  -.9 .0  text "Anterior"  as text1
gfx cre annotation position  .45 -.9 .0  text "Posterior" as text2
gfx draw text1 scene overlay
gfx draw text2 scene overlay




# Create the Movie
#
#gfx modify spectrum act clear overwrite_colour
#gfx modify spectrum act linear reverse range 0 50 extend_ab extend_be rainbow 
gfx mod spect act linear range -100 120 banded number_of_ba 2 band_ratio 0.01
#gfx read node /usr/tmp/cheng/activ_trsf/forward_01_1010


var set 1 1002
var set 2 104
# gfx movie create /tmp/pig_potentials.movie win 1
# open com movie exec 25
# gfx movie end
