# Example e42
# -----------
#


# Inputs
#

$SLAVEFILES 	= "pig06"
$CUSTFILES 	= "pig06_cust"
$SLAVE 		= "1..6"
$HOST 		= 7



# Controls
#

$CALCXI 	= 1
$FITTING 	= 1
$UPDATE 	= 1 #Update the slave mesh.
$OUTPUT		= 1 #Write out ipnode/elem files.



fem def para;r;fitting;example
fem def regi;r;seven;example
fem def coor 3,1
fem def base;r;bicubic_tricubic;example


if( $CALCXI==1 )
{
fem def node;r;host;example reg $HOST
fem def elem;r;host;example reg $HOST
fem up node deriv 1 reg $HOST
fem up node deriv 2 reg $HOST
fem up node deriv 3 reg $HOST


#
#----------------------------#
# Refine host mesh
#----------------------------#
fem ref xi 3 reg $HOST


#
#----------------------------#
# Export host geometry
#----------------------------#
#
fem export node;host as host offset 1000 reg $HOST
fem export elem;host as host offset_elem 1000 reg $HOST


#
#----------------------------#
# Calculate xi's for data points
#----------------------------#
#
fem def data;r;gen_landmark9;example reg $HOST
fem def xi;c contain reg $HOST
fem export data;gen_landmark as gen_landmark error offset 16000 reg $HOST
fem def xi;w;gen_landmark reg $HOST


#
#----------------------------#
# The slave mesh
#----------------------------#
#
fem def node;r;$SLAVEFILES;example reg $SLAVE
fem def elem;r;$SLAVEFILES;example reg $SLAVE

fem export node;pig_gen as pig_gen offset 10000 reg $SLAVE
fem export elem;pig_gen as pig_gen offset_elem 10000 reg $SLAVE


#
#----------------------------#
# Calculate xi's for node points
#  calcs the xi posns of nodes 
#  in nr2 contained by host in nr1
#----------------------------#
#
fem def xi;c nodes contain of $SLAVE in $HOST
fem def xi;w;generic nodes contain of $SLAVE in $HOST



} #CALCXI

