

$MODEL 	= "epi_ref0"
$OUTPUT = "epi_ref0c"
$FITNAME = "epi"





fem def para;r;fitting_lin;example
fem def coor 3,1


#
# Sets up three basis functions 
#   - 1 standard bicubic Hermite element
#   - 2 simplex element collapsed at x2=0
#   - 3 simplex element collapsed at x2=1
#
fem def base;r;bicubic_fit;example

#
# Reads in an initial mesh and calculates linear approximations
#  for the derivatives in xi=1 and 2 directions
#
fem def node;r;$MODEL;example
fem def elem;r;$MODEL;example
fem up node deriv 1 linear
fem up node deriv 2 linear

#
# The initial mesh
#
fem export node;${FITNAME}_init as ${FITNAME}_init offset 40000
fem export elem;${FITNAME}_init as ${FITNAME}_init offset_elem 40000


#
# Calculate the intial xi projections 
#   - alternatively the command fem def xi;c orthog can be used
#     it is slower but may produce better results in some cases
#
fem def data;r;$FITNAME;example
fem def xi;c close
fem li data err 
fem export data;${FITNAME}_data as ${FITNAME}_data error


#
# Setup the fitting problem - 
#  NOTE - alternatively it may be easier use the commands
#  "fem up field from geometry" to setup these fields automatically
#
fem def field;r;epi;example
fem def elem;r;epi;example field

#
# Defines the fitting problem by setting smoothing parameters
#  and setting some fixed nodes.
#
fem def fit;r;epi2;example geometry


