#
# Example e83 - Signal fitting with no cross derivatives
#

$FORMAT = "binary" #set a fileformat

fem def para;r;full_pig;example         #define parameters
fem realloc
fem def coor 3,1                        #rc coordinates
fem def regi;r;full_pig;example         #one region
fem def base;r;full_pig;example         #bicubic Herm surfaces with sectors
fem def node;r;torso_cust;example       #p111 customised surface
fem def elem;r;torso_cust;example

#
#
# Export surface to CMGUI
#
fem export node;porky as porky
fem export elem;porky as porky


fem def data;r;p111_trans;example        #define data
fem def xi;r;p111;example
fem export data;p111 as elec error offset 10500
#                                        !outputs the data positions and
#                                        !error vectors denoted by error

#
#   Fit the signal 
#      - between 0.1 and 0.2 skipping every 5 time steps
#
fem def field;r;torso_surface;example      # bicubic Hermite field
fem def;add base;r;no_cross;example        # bicubic Herm surfaces with sectors
fem def elem;r;torso_surface;example field   # element fields
fem update scale_factors estimate          # need scale factors for new bases
fem def fit;r;torso_surface;example signal class 2
# link the binsig file to the current directory for fit sig
symlink $example.'green_up2.binsig', 'green_up2.binsig';
fem fit sig class 2 $FORMAT tstart 0.10 tend 0.20

#
#
#   Export the fitted (nodally based) signals to UNEMAP
#
fem eva elec;fitted hist fitted fr node elec 13..213 $FORMAT us fit cl 2
fem conv sig from bin infile fitted  outfile fitted
fem def export;r;unemap;example
fem export sig;fitted elec signal fitted

#
#
#   Export reconstructed signals (from the input data pts) 
#    for a comparison
#
fem def data;r;p111_surf;example
fem def xi;r;p111;example
fem eva elec;fitted_data hist fitted fr data $FORMAT us fit cl 2
fem conv sig from bin infile fitted_data  outfile fitted_data

#
#
# Export the nodal signals to UNEMAP
#
fem eva elec;p111 hist fitted fr node elec 13..213 $FORMAT us fit cl 2
fem def export;r;unemap;example
fem export sig;p111 elec signal p111 

#
# Export signals to CMGUI
#

fem export node;solutions history fitted as solutions using fit cl 2 $FORMAT
fem export elem;solutions field as solutions using fit cl 2

