
#=====================
#Assign region numbers
#=====================

# Command updated by fixcom.sh on Wed Aug 23 17:50:53 NZT 2000
# Old command: assign variable CAVITY 1
$CAVITY = 1


# Command updated by fixcom.sh on Wed Aug 23 17:50:53 NZT 2000
# Old command: assign variable LLUNG 2
$LLUNG = 2


# Command updated by fixcom.sh on Wed Aug 23 17:50:53 NZT 2000
# Old command: assign variable RLUNG 3
$RLUNG = 3


# Command updated by fixcom.sh on Wed Aug 23 17:50:53 NZT 2000
# Old command: assign variable VENTS 4
$VENTS = 4


# Command updated by fixcom.sh on Wed Aug 23 17:50:53 NZT 2000
# Old command: assign variable HEART 5
$HEART = 5


# Command updated by fixcom.sh on Wed Aug 23 17:50:53 NZT 2000
# Old command: assign variable MUSCLE 6
$MUSCLE = 6


# Command updated by fixcom.sh on Wed Aug 23 17:50:53 NZT 2000
# Old command: assign variable GRIDHT 7
$GRIDHT = 7


#=========================
#Define problem parameters
#=========================

# Command updated by fixcom.sh on Wed Aug 23 17:50:53 NZT 2000
# Old command: assign variable PLAPLACE 1
$PLAPLACE = 1

#PLAPLACE involves all regions except GRIDHT

# Command updated by fixcom.sh on Wed Aug 23 17:50:53 NZT 2000
# Old command: assign variable TLAPLACE 2
$TLAPLACE = 2

#TLAPLACE involves only regions outside the HEART

# Command updated by fixcom.sh on Wed Aug 23 17:50:53 NZT 2000
# Old command: assign variable BLAPLACE 3
$BLAPLACE = 3

#BLAPLACE involves only the VENTS region
 
#=========================
#Define problem parameters
#=========================
fem define para;r;torsoslice;example
fem reallocate
fem define regi;r;torsoslice;example
fem define base;r;torsoslice;example
 
#=======================
#Define problem geometry
#=======================
fem define node;r;cavity;example reg $CAVITY
fem define elem;r;cavity;example reg $CAVITY
fem define node;r;llung;example reg $LLUNG
fem define elem;r;llung;example reg $LLUNG
fem define node;r;rlung;example reg $RLUNG
fem define elem;r;rlung;example reg $RLUNG
fem define node;r;heartcomb;example reg $HEART
fem define elem;r;heartcomb;example reg $HEART
fem define node;r;vents;example reg $VENTS
fem define elem;r;vents;example reg $VENTS
fem define node;r;muscle;example reg $MUSCLE
fem define elem;r;muscle;example reg $MUSCLE
fem define node;r;heart-slice;example reg $GRIDHT
fem define elem;r;heart-slice;example reg $GRIDHT

#================================
#Define fibres in finite elements
#================================
fem define fibr;r;muscle;example reg $MUSCLE
fem define elem;r;muscle;example reg $MUSCLE fibre
fem define fibr;r;heart-slice;example reg $GRIDHT
fem define elem;r;heart-slice;example fibre reg $GRIDHT

#================
#Define equations
#================
fem define equa;r;bem;example reg $CAVITY,$LLUNG,$RLUNG,$VENTS,$HEART,$MUSCLE class $PLAPLACE lock
fem define equa;r;torso;example reg $CAVITY,$LLUNG,$RLUNG,$MUSCLE class $TLAPLACE lock
fem define equa;r;blood;example reg $VENTS class $BLAPLACE lock

#==========================
#Define material properties
#==========================
fem define mate;r;bem;example reg $CAVITY,$LLUNG,$RLUNG,$VENTS,$HEART,$MUSCLE class $PLAPLACE
fem define mate;r;torso;example reg $CAVITY,$LLUNG,$RLUNG,$MUSCLE class $TLAPLACE
fem define mate;r;blood;example reg $VENTS class $BLAPLACE

#=========================
#Define initial conditions
#=========================
fem define init;r;bem;example reg $CAVITY,$LLUNG,$RLUNG,$VENTS,$HEART,$MUSCLE class $PLAPLACE
fem define init;r;torso;example reg $CAVITY,$LLUNG,$RLUNG,$MUSCLE class $TLAPLACE
fem define init;r;blood;example reg $VENTS class $BLAPLACE

#====================================
#Define coupling and normal reversals
#====================================
fem define coup;r;heart-slice;example class $PLAPLACE
fem define coup;r;heart-slice;example class $TLAPLACE
fem define norm;r;ventricle_refx3;example

#=========================
#Define solution paramters
#=========================
fem define solv;r;bem;example coupled reg $CAVITY,$LLUNG,$RLUNG,$VENTS,$HEART,$MUSCLE class $PLAPLACE
fem define solv;r;torso;example coupled reg $CAVITY,$LLUNG,$RLUNG,$MUSCLE class $TLAPLACE
fem define solv;r;blood;example reg $VENTS class $BLAPLACE

#=================
#Solve the problem
#=================
fem solve coupled reg $CAVITY,$LLUNG,$RLUNG,$VENTS,$HEART,$MUSCLE class $PLAPLACE

#================================================================
#Update the solution to the other classes for boundary conditions
#================================================================
fem update solution dependent from_class $PLAPLACE to_class $TLAPLACE region $CAVITY
fem update solution dependent from_class $PLAPLACE to_class $BLAPLACE region $VENTS

#=========================
#Solve the two subproblems
#=========================
fem solve coupled reg $CAVITY,$LLUNG,$RLUNG,$MUSCLE class $TLAPLACE
fem solve reg $VENTS class $BLAPLACE
