#
# Created by Martin Buist
# August 2001
#

if( !$example ) {
  $example = ".";
}

fem define para;r;$example/bemcircle
fem define regi;r;$example/bemcircle
fem define node;r;$example/bemcircle reg 1
fem define node;r;$example/test reg 2
fem define base;r;$example/test
fem define elem;r;$example/bemcircle reg 1
fem define elem;r;$example/test reg 2
fem define grid;r;$example/test reg 2
fem update grid geometry reg 2

fem define equa;r;$example/bemcircle reg 1 cl 1 lock
fem define equa;r;$example/test reg 2 cl 2 lock
fem define mate;r;$example/bemcircle reg 1
fem define anal;r;$example/bemcircle reg 1
fem define init;g reg 1
fem define solv;r;$example/bemcircle reg 1

# Solve the BEM problem
fem solve reg 1
# Domain solution calculation - normal
fem eval solu grid elem 31 cpcutoff 0.9 gradient
fem export elem;test-debug as test reg 2 cl 2 field iy 2
fem export elem;test-debug2 as test reg 2 cl 2 field iy 3

# Domain solution calculation - optimised with adaptive integration
fem eval solu grid elem 31 opti cpcutoff 0.9 gradient

# Export dphi/dx
fem export elem;test-opti as test reg 2 cl 2 field iy 2
# Export dphi/dy
fem export elem;test-opti2 as test reg 2 cl 2 field iy 3

fem export node;test as test reg 2
fem export elem;test as test reg 2

#Combine the two directions into a single file

sub WriteGradPhiExelem {

  my ( $DXFILENAME, $DYFILENAME, $OUTPUTNAME ) = @_;

  my $Found = 0;
  my $Found2 = 0;
  my $First = 1;
  my $InputLine = ' ';

  CORE::open( OUTPUTFILE,">$OUTPUTNAME" )	or die( "ERROR: Unable to open output file\n" );
  CORE::open( INPUTFILE,"<$example"."/"."$DXFILENAME" ) or die( "ERROR: Unable to open DX input file\n" );

  while( <INPUTFILE> ) {
			if( /Nodes:/ ) {
				my $Inputline = $_;

				$Found2 = 0;
        CORE::open( INPUTFILE2,"<$example"."/"."$DYFILENAME" ) or die( "ERROR: Unable to open DY input file\n" );
				while( <INPUTFILE2> ) {
						if( /Nodes:/ ) {
								$Found2 = 0;
						}
						if( $Found2 ) {
								print( OUTPUTFILE "$_" );
						}
						if( /Values:/ ) {
								$Found2 = 1;
						}
				}
				CORE::close( INPUTFILE2 );

				print( OUTPUTFILE "$Inputline" );
			}
			if( !$Found ) {
				print( OUTPUTFILE $_ );
			} elsif( $First ) {
        print( OUTPUTFILE ' 1) gradphi, field, rectangular cartesian, #Components=2'."\n");
        print( OUTPUTFILE '   x.  l.Lagrange*l.Lagrange, no modify, grid based.'."\n");
				$First = 0;
			} 
			if( /Fields/ ) {
				$Found = 1;
			}
			if( /xi1/ ) {
				print( OUTPUTFILE $_ );
        print( OUTPUTFILE '   y.  l.Lagrange*l.Lagrange, no modify, grid based.'."\n");
				print( OUTPUTFILE $_ );
			}
			if(( /Element/ ) && $Found ) {
				print( OUTPUTFILE $_ );
				$Found = 0;	
			}
	}
  CORE::close( INPUTFILE );
  CORE::close( OUTPUTFILE );
  
} # WriteGradPhiExelem

$DXFILENAME = "test-opti.exelem";
$DYFILENAME = "test-opti2.exelem";
$OUTPUTNAME = "gradients.exelem";

WriteGradPhiExelem( $DXFILENAME, $DYFILENAME, $OUTPUTNAME );
