fem define parameter;r;tube;example      # Declares array dimensions
fem reallocate;
fem define coordinate;r;tube;example     # Defines the coordinate system
fem define node;r;tube;example           # Reads in nodal information
fem define base;r;tube;example           # Defines basis function (02 funcns : 1. 1D cubic hermite 2. 1D linear)
fem define element;r;tube;example        # Reads in element information
fem define field;r;tube;example          # Reads in fields. Only first field (unstressed radius at nodes) is necessary for this problem
fem define element;r;tube;example field  # Defines interpolation of field variables (linear)
fem define grid;r;tube;example coronary  # Defines grid points with coronary option to discretise the spatial computational domain. 
fem update grid geometry;
fem define equation;r;tube;example       # Defines equations                          
fem define material;r;tube;example       # Reads in physical & mechanical properties
fem update material field material 4 no_field 1;
#                                        # Updates unstressed radius (mat 4) from field 1
fem define time;r;step;example           # Define boundary conditions. Step increase in press. at inlet. Constant press. at outlet
fem define initial;r;tube;example        # Defines initial conditions
fem define solve;r;tube;example          # Defines solution parameters

$time_initial=0.00;                      # Sets the initial time
$time_final=0.04;                        # Sets the final time
$time_step=0.0001;                       # Sets the time step time
$write_out_period=0.001;                 # Sets the results write out period

fem export points;$time_initial grid as vessel offset 0;         
fem export grid;vessel as vessel offset_node 0 elastic_tube; 

# Results output loop

for ($time=$time_initial;$time<$time_final;$time=$time+$write_out_period)       
{                                                                           
fem solve restart to $write_out_period delta_t $time_step;
fem export points;$time+$write_out_period grid as vessel offset 0           
}                                                                           

