#Example i21

$OUT = '.'
if (!defined $example)
{
  $example ='.'
}

$resolution = '2x4'
$resolution = '4x8'

$interpolation = 'cubic'
$interpolation = 'linear'

fem define para;r;$example/torsotimedep
fem define coor 3,1
fem define regi;r;$example/two
fem define base;r;$example/bi$interpolation

if( $resolution eq '2x4' ) {
  fem define node;r;$example/sphere_1 reg 1
  fem define elem;r;$example/sphere_1 reg 1
} elsif( $resolution eq '4x8' ) {
  fem define node;r;$example/sphere_2 reg 1
  fem define elem;r;$example/sphere_2 reg 1
}

fem define node;r;$example/cube reg 2
fem define elem;r;$example/cube reg 2

#
# Export geometry
#
fem export node;$OUT/sphere as sphere
fem export elem;$OUT/sphere as sphere
fem export node;$OUT/cube   as cube reg 2
fem export elem;$OUT/cube   as cube reg 2


fem define grid;r;$example/cube   reg 2
fem update grid geometr            reg 2
fem define equa;r;$example/laplace_bem_$interpolation reg 1 class 1 lock
fem define mate;r;$example/laplace reg 1 class 1
fem define sour;r;$example/dipole  reg 1 class 1

fem de anal;r;$example/eccentricdipole reg 1 cl 1
fem de init;g reg 1 cl 1
fem define solv;r;$example/nosalu_$interpolation reg 1 class 1
fem define equa;r;$example/laplace_grid reg 2 class 2 lock

#
# Solve and export potential due to a dipole
#
fem solve reg 1 class 1
fem export node;$OUT/sphere_pot as sphere field
fem export elem;$OUT/sphere_pot as sphere field


#
# Read in perl subroutine: WriteGradPhiExelem
#  which combines 3 scalar exelem files into a vector field
#
read com;$example/perl


#
# Full magnetic field
#
#fem eval solu magnet grid elem 551 iy 1 both analytic
fem eval solu magnet grid elem 551 iy 1 both

fem export elem;$OUT/xpote as cube field reg 2 class 2 iy 2 grid_numbers
fem export elem;$OUT/ypote as cube field reg 2 class 2 iy 3
fem export elem;$OUT/zpote as cube field reg 2 class 2 iy 4

#
# Combine the 3 scalar field into a single vector field
#
$DXFILENAME="$OUT/xpote.exelem";
$DYFILENAME="$OUT/ypote.exelem";
$DZFILENAME="$OUT/zpote.exelem";
$OUTPUTNAME="$OUT/H_both.exelem";
&WriteGradPhiExelem($DXFILENAME,$DYFILENAME,$DZFILENAME,$OUTPUTNAME);

#
# Export the magnetic field at "electrodes"
#
fem def data;r;$example/elec field num 3
fem eval solu mag data
fem export data;$OUT/elec as elec num_field 3 field_name mag

