set Num_threads 1

# Set up region
$intestine = 1;
# Set up class
$active1 = 1;

# Read in geometry of the duodenum
fem define para;r;$example/3layers_duo
fem de coor 3,1
fem define nodes;r;$example/3layers_duo reg $intestine
fem de base;r;$example/3layers_duo
fem define ele;r;$example/3layers_duo reg $intestine

# Add fibre into the CM and LM layers
fem def fibr;r;$example/3layers_duo reg $intestine 	
fem def elem;r;$example/3layers_duo fibre reg $intestine #trilinear interpolation

# Apply different grid schemes to each layer
fem define grid;r;$example/3layers_duo reg $intestine
fem update grid geometry reg $intestine

# Group the facses to allow connection
fem group grid face xi3 low element 321..480 as ICC1 reg $intestine
fem group grid face xi3 low element 161..320 as ICC2 reg $intestine

# Group the different layers
fem group grid element 321..480 as LM reg $intestine			
fem group grid element 161..320 as ICC reg $intestine
fem group grid element 1..160 as CM reg $intestine
fem group grid external as boundary reg $intestine

#cuts the connection in the xi3 direction ie. between ICC and LM
fem update grid conn grid ICC1 direction 3 reg $intestine		
#cuts the connection in the -xi3 direction ie. between ICC and CM
fem update grid conn grid ICC2 direction -3 reg $intestine	

# Define the activation in the duodenum
fem define equ;r;$example/ICCcmiss_mono reg $intestine class $active1
fem define cell;r;$example/ICCcmiss_mono reg $intestine class $active1
fem define mate;r;$example/ICCcmiss_mono reg $intestine class $active1 cell
fem define mate;r;$example/ICCcmiss_mono reg $intestine class $active1
fem define init;r;$example/ICCcmiss_mono reg $intestine class $active1
fem define solv;r;$example/ICCcmiss_mono reg $intestine class $active1

# Perform an initial solve
fem solve to 0 reg $intestine class $active1

# Export duodenum geometry
fem export node;intestine reg $intestine as intestine
fem export elem;intestine reg $intestine as intestine 
fem export elem;intestine_mono_pot_0 reg $intestine class $active1 field as intestine;
fem export elem;grid reg $intestine class $active1 as intestine grid_numbers
fem export elem;fibre as intestine fibre

# Solve with a time step of 0.02s and output every 1s
$counter=50;
$over_time=5;
$step=0.02;
$endloop=$over_time/$step
for $M ( 0..$endloop) {
	$time=$M*$step;
	# Reconnect layers
	fem update grid stimulus grid ICC1,ICC2 diffusion 0.3 up_potential direction 3 reg $intestine class $active1
	fem solve restart to $time reg $intestine class $active1

	if ($counter>=49) {
		print $time
		# Export the electrical activity solution
		fem export ele;intestine_mono_pot_$time reg $intestine class $active1 field as intestine; 
		# Calculate the dipole source per element
		fem define sour;c grid grregion $intestine grclass $active1 time $time;
		$counter=0;
        }else {
		$counter++;	
	}
}

# Write out the dipole sources
fem define sour;w;dipoles_elem grid grregion $intestine grclass $active1
fem export sour;dipole_all as dipole
