#!/usr/bin/perl -w
#
# This is a perl script to count nodes in an ipnode file
#
# Usage:
#
# Created:
# 

use strict;
use File::Compare;
use File::Find;
use Getopt::Std;


sub update_file
{
        # Given the input filename this routine parses
        # the given file and counts the nodes
        my $input1 = shift;
        my $input2 = shift;
        my $output = shift;
        my $line;
        my $node_number_line = " Node number";
        my $coord1_line = " The Xj(1) coordinate is";
        my $coord2_line = " The Xj(2) coordinate is";
        my $coord3_line = " The Xj(3) coordinate is";
        my $derivative_line = " The derivative";
        my $node_number;
        my @node_position;

        open(INPUT1, "<$input1") || die "Could not open file $input1: $!\n";
        open(INPUT2, "<$input2") || die "Could not open file $input2: $!\n";
        open(OUTPUT, ">$output") || die "Could not open file $output: $!\n";
         
        while (defined($line = <INPUT1>))
        {
           my @fields = split (' ',$line);
					 my $last = $#fields;
           if (($line =~ m|\Q$node_number_line\E|))
           {
               $node_number = $fields[$last];
           }
					 elsif(($line =~ m|\Q$coord1_line\E|))
					 {
               $node_position[$node_number][1]=$fields[$last];
					 }
					 elsif(($line =~ m|\Q$coord2_line\E|))
					 {
               $node_position[$node_number][2]=$fields[$last];
					 }
					 elsif(($line =~ m|\Q$coord3_line\E|))
					 {
               $node_position[$node_number][3]=$fields[$last];
					 }
        }

        while (defined($line = <INPUT2>))
        {
           my @fields = split (' ',$line);
					 my $last = $#fields;
           if (($line =~ m|\Q$node_number_line\E|))
           {
               $node_number = $fields[$last];
							 print OUTPUT $line;
           }
					 elsif(($line =~ m|\Q$coord1_line\E|))
					 {
               $fields[$last]=$node_position[$node_number][1];
							 for (my $i=0;$i<=$#fields;$i++)
							 {						
									 print OUTPUT " ",$fields[$i];
							 }
									 print OUTPUT "\n";

					 }
					 elsif(($line =~ m|\Q$coord2_line\E|))
					 {
               $fields[$last]=$node_position[$node_number][2];
							 for (my $i=0;$i<=$#fields;$i++)
							 {						
									 print OUTPUT " ",$fields[$i];
							 }
									 print OUTPUT "\n";
					 }
					 elsif(($line =~ m|\Q$coord3_line\E|))
					 {
               $fields[$last]=$node_position[$node_number][3];
							 for (my $i=0;$i<=$#fields;$i++)
							 {						
									 print OUTPUT " ",$fields[$i];
							 }
									 print OUTPUT "\n";
					 }
#					 elsif(($line =~ m|\Q$derivative_line\E|))
#					 {
#               $fields[$last]=0;
#							 for (my $i=0;$i<=$#fields;$i++)
#							 {						
#									 print OUTPUT " ",$fields[$i];
#							 }
#									 print OUTPUT "\n";
#					 }
           else
					 {
							 print OUTPUT $line;
					 }
        }







        close (INPUT1);
        close (INPUT2);
        close (OUTPUT);
}


update_file($ARGV[0],$ARGV[1],$ARGV[2])


